function Trier(fichiers)
   local tmp1, tmp2
   for j=1,table.getn(fichiers) do
      for i=3,table.getn(fichiers)-1 do

         tmp1= fichiers[i]
         if tmp1.directory==false then
            fichiers[i]= fichiers[i+1]
            fichiers[i+1]= tmp1
         end
      end
   end
   for j=1,table.getn(fichiers) do
      for i=3,table.getn(fichiers)-1 do
         if fichiers[i].directory==fichiers[i+1].directory then
            tmp1= fichiers[i]
            tmp2= fichiers[i+1]
            if string.lower(tmp1.name)>string.lower(tmp2.name) then
               fichiers[i]= fichiers[i+1]
               fichiers[i+1]= tmp1
            end
         end
      end
   end
   return fichiers
end

function Afficher_partie(i, pos, fichiers)
   if fichiers[i].name=="." or fichiers[i].name==".." or fichiers[i].directory==true then
      screen:blit(20, pos*22+42, image.repertoire)
   else
      local nom= string.lower(string.sub(fichiers[i].name, string.len(fichiers[i].name)-3))
      if nom==".txt" then
         screen:blit(20, pos*22+42, image.text)
      elseif nom==".jpg" or string.lower(string.sub(fichiers[i].name, string.len(fichiers[i].name)-4))==".jpeg" or nom==".gif" or nom==".bmp" or nom==".png"  then
         screen:blit(20, pos*22+42, image.image2)
      elseif nom==".lua" then
         screen:blit(20, pos*22+42, image.lua)
      elseif nom==".mp3" or nom==".wav" then
         screen:blit(20, pos*22+42, image.musique)
      else
         screen:blit(20, pos*22+42, image.image1)
      end
   end
   screen:print(48, pos*22+48, fichiers[i].name, couleur.blanc)
   if not fichiers[i].directory then
      do
         local a= fichiers[i].size
         if a>1024*1024 then
            a= ((math.floor(a/(1024*1024)*10))/10).." mo"
         elseif a>1024 then
            a= ((math.floor((a/1024)*10))/10).." ko"
         else
            a= a.." o"
         end
         screen:print(472-8*string.len(a), pos*22+48, a, couleur.blanc)
      end
   end
end

function Explorer(fichiers)
   fichiers= nil
   System.currentDirectory(dossier_en_cours)
   fichiers= System.listDirectory()
   return Trier(fichiers)
end

function Afficher_contenu(debut, fichiers)
   for i=debut, debut+7 do
      Afficher_partie(i, i-debut+1, fichiers)
      if i>=table.getn(fichiers) then
         break
      end
   end 
end

function Afficher_selectionneur(yselectionneur, max, n_liste, coul)
   screen:fillRect(0, yselectionneur*22+64-22, 480, 21, coul)
   if ((pad:analogY()>50 and not option.clavier) or (pad:down() and not oldpad:down())) and yselectionneur+n_liste<max then
      if yselectionneur<8 then
         yselectionneur= yselectionneur + 1
      else
         n_liste= n_liste + 1
      end
   end
   if ((pad:analogY()<-50 and not option.clavier) or (pad:up() and not oldpad:up())) and yselectionneur+n_liste>1 then
      if yselectionneur>1 then
         yselectionneur= yselectionneur - 1
      else
         n_liste= n_liste - 1
      end
   end
   return yselectionneur, n_liste
end

function Aff_ouvrir()
   screen:clear(couleur.noir)
   screen:fillRect(0, 0, 480, 29, couleur.bleu)
   screen:fillRect(1, 1, 478, 27, couleur.gris)
   screen:print(216, 10, "OUVRIR", couleur.blanc)
   screen:print(17,44,System.currentDirectory(), couleur.bleu)
   screen:fillRect(319, 240, 72, 15, couleur.bleu)
   screen:fillRect(399, 240, 72, 15, couleur.bleu)
   screen:print(321,244,"L:Annuler R:Valider", couleur.blanc)
end

function Ouvrir()
   local n_liste= 0
   local yselectionneur= 3
   local file, fichiers
   System.currentDirectory(dossier_en_cours)
   fichiers= Explorer(fichiers)
   while true do
      pad= Controls.read()
            
      Aff_ouvrir()

      yselectionneur, n_liste= Afficher_selectionneur(yselectionneur, table.getn(fichiers), n_liste, couleur.bleu)
      Afficher_contenu(n_liste+1, fichiers)
      
      if pad:left() and not oldpad:left() then
         if dossier_en_cours~="ms0:/" then   --
            dossier_en_cours= System.currentDirectory().."/.."
            fichiers= Explorer(fichiers)
            yselectionneur= 2
            n_liste= 0
         end
      end

      if (pad:right() and not oldpad:right()) or (pad:cross() and not oldpad:cross()) or (pad:r() and not oldpad:r()) then
         do
            local nom= string.lower(string.sub(fichiers[yselectionneur+n_liste].name, string.len(fichiers[yselectionneur+n_liste].name)-3))
            if dossier_en_cours=="ms0:/" then   --
               dossier_en_cours= System.currentDirectory()
            else
               dossier_en_cours= System.currentDirectory().."/"
            end
            if not fichiers[yselectionneur+n_liste].directory then
               if nom==".jpg" or string.lower(string.sub(fichiers[yselectionneur+n_liste].name, string.len(fichiers[yselectionneur+n_liste].name)-4))==".jpeg" or nom==".gif" or nom==".bmp" or nom==".png" then
                  screen:clear(couleur.noir)
                  screen:blit(0, 0, Image.load(dossier_en_cours..fichiers[yselectionneur+n_liste].name))
                  screen.waitVblankStart()
                  screen.flip()
                  while pad:circle() or pad:start() or pad:cross() do
                     pad= Controls.read()
                  end
                  while not pad:cross() and not pad:circle() and not pad:start()do
                     pad= Controls.read()
                  end
               else
                  option.hex= false
                  name= fichiers[yselectionneur+n_liste].name
                  save= {}
                  file= io.open(dossier_en_cours..fichiers[yselectionneur+n_liste].name)
                  screen:clear()
                  screen:print(144, 128, "Ouverture du fichier...", couleur.blanc)
                  screen.flip()
                  for line in file:lines() do
                     save[table.getn(save)+1]= line
                  end
                  file:close()
                  Process()
                  return true
               end
            end
            if fichiers[yselectionneur+n_liste].directory then
               if dossier_en_cours== "ms0:/" then
                  dossier_en_cours= System.currentDirectory()..fichiers[yselectionneur+n_liste].name
               else
                  dossier_en_cours= System.currentDirectory().."/"..fichiers[yselectionneur+n_liste].name
               end
               fichiers= Explorer(fichiers)
               yselectionneur= 2
               n_liste= 0
            end
         end
      end
      
      if pad:triangle() and not oldpad:triangle() and not fichiers[yselectionneur+n_liste].directory then
         name= fichiers[yselectionneur+n_liste].name
         if dossier_en_cours=="ms0:/" then   --
            dossier_en_cours= System.currentDirectory()
         else
            dossier_en_cours= System.currentDirectory().."/"
         end
         save= {}
         do
            screen:clear()
            screen:print(144, 128, "Ouverture du fichier...", couleur.blanc)
            screen.flip()
            if option.hex then
               f_hex:close()
            end
            modif= {}
            option.hex= true
            option.coloration= false
            option.numero_lignes= false
            option.autocomp= false
            option.aide= false
            f_hex= io.open(dossier_en_cours..name, "rb")
            cadre.y= 1
            Charger_bloc()
            return true
         end
      end
      
      if pad:select() and pad:triangle() and not option.clavier then
         while pad:select() or pad:triangle() do
            pad= Controls.read()
         end
         if Confirmer("Avertissement", "Effacer le fichier:", fichiers[yselectionneur+n_liste].name.." ?", "Effacer", "Ne pas effacer") then
            if fichiers[yselectionneur+n_liste].directory then
               System.removeDirectory(fichiers[yselectionneur+n_liste].name)
            else
               System.removeFile(fichiers[yselectionneur+n_liste].name)
            end
            fichiers= Explorer(fichiers)
            if yselectionneur+n_liste>table.getn(fichiers) then
               if yselectionneur>1 then
                  yselectionneur= yselectionneur-1
               else
                  n_liste= n_liste-1
               end
            end
         end
      end
      
      if pad:l() and not oldpad:l() then
         System.currentDirectory(dossier_en_cours)
         return false
      end
   
      screen.waitVblankStart()
      screen.flip()
      oldpad= pad
   end
end

function Cursor(txt_fichier)
   screen:blit(curseur.x*8+65, 243, image.curseur)
   if pad:right() and not oldpad:right() and curseur.x<305 and curseur.x<string.len(txt_fichier) then
      curseur.x= curseur.x + 1
   end
   if pad:left() and not oldpad:left() and curseur.x>0 then
      curseur.x= curseur.x - 1
   end
end

function Aff_enregistrer()
   screen:clear(couleur.noir)
   screen:fillRect(0, 0, 480, 29, couleur.rouge)
   screen:fillRect(1, 1, 478, 27, couleur.gris)
   screen:print(196, 10, "ENREGISTRER", couleur.blanc)
   screen:print(17,44,System.currentDirectory(), couleur.rouge)
   
   screen:fillRect(319, 240, 72, 15, couleur.rouge)
   screen:fillRect(399, 240, 72, 15, couleur.rouge)
   screen:print(320,244,"L:Annuler R:Valider", couleur.blanc)
   screen:fillRect(61, 240, 248, 15, couleur.gris)
   Cursor(statut.val[1])
   
   screen:print(27,244,"Nom: "..statut.val[1], couleur.blanc)
end

function Enregistrer()
   local n_liste= 0
   local yselectionneur= 3
   local save_x= curseur.x
   local file, fichiers
   fichiers= Explorer(fichiers)
   statut.val[1]= name
   System.currentDirectory(dossier_en_cours)
   local repertoire_defaut= System.currentDirectory()
   curseur.x= 0

   while true do
      pad= Controls.read()
      
      Aff_enregistrer()
      yselectionneur, n_liste= Afficher_selectionneur(yselectionneur, table.getn(fichiers), n_liste, couleur. rouge)
      Afficher_contenu(n_liste+1, fichiers)

      if pad:left() and not oldpad:left() then
         if dossier_en_cours~="ms0:/" then   --
            dossier_en_cours= System.currentDirectory().."/.."
            fichiers= Explorer(fichiers)
            yselectionneur= 2
            n_liste= 0
         end
      end

      
      if pad:r() and not oldpad:r() and not option.clavier then
         name= statut.val[1]
         if option.hex then
            do
               local fichier
               local data

               screen:clear()
               screen:print(136, 128, "Sauvegarde du fichier...", couleur.blanc)
               screen.flip()

               f_hex:seek("set")            
               data= f_hex:read("*all")
               f_hex:close()
               fichier= io.open(statut.val[1], "wb")
               fichier:write(data)
               for i= 1, table.getn(modif) do
                  fichier:seek("set", modif[i][1])
                  if modif[i][2]==0 then
                     fichier:write("\0")
                  else
                     fichier:write(string.format("%c", modif[i][2]))
                  end
               end
               fichier:close()
               modif= {}
               f_hex= io.open(statut.val[1], "rb")
            end
         else
            screen:clear()
            screen:print(136, 128, "Sauvegarde du fichier...", couleur.blanc)
            screen.flip()

            file= io.open(statut.val[1], "w")
            if table.getn(save)>0 then
               for i=1, table.getn(save) do
                  file:write(save[i].."\n")
               end
            end
            file:close()
            System.currentDirectory(repertoire_defaut)
            option.clavier= false
         end
         curseur.x= save_x
         return
      end
      
      if pad:cross() and not oldpad:cross() and not option.clavier and yselectionneur+n_liste<table.getn(fichiers) then
         if fichiers[yselectionneur+n_liste].directory then
            if dossier_en_cours== "ms0:/" then
               dossier_en_cours= System.currentDirectory()..fichiers[yselectionneur+n_liste].name
            else
               dossier_en_cours= System.currentDirectory().."/"..fichiers[yselectionneur+n_liste].name
            end
            fichiers= Explorer(fichiers)
            yselectionneur= 2
            n_liste= 0
         end
      end
      
      if pad:l() and not oldpad:l() and not option.clavier then
         System.currentDirectory(repertoire_defaut)
         option.clavier= false
         curseur.x= save_x
         return
      end
      
      if option.clavier then
         do
            local texte
            texte= Clavier(323, 100)
            if texte~=nil then
               statut.val[1]= Inserer_texte(texte, statut.val[1])
            end
         end
      end
      
      if pad:select() and pad:triangle() and not option.clavier then
         while pad:select() or pad:triangle() do
            pad= Controls.read()
         end
         do
            local conf= Confirmer("Avertissement", "Effacer le fichier:", fichiers[yselectionneur+n_liste].name.." ?", "Effacer", "Ne pas effacer")
            if conf then
               if fichiers[yselectionneur+n_liste].directory then
                  System.removeDirectory(fichiers[yselectionneur+n_liste].name)
               else
                  System.removeFile(fichiers[yselectionneur+n_liste].name)
               end
            end
         end
         fichiers= Explorer(fichiers)
         if yselectionneur+n_liste>table.getn(fichiers) then
            if yselectionneur>1 then
               yselectionneur= yselectionneur-1
            else
               n_liste= n_liste-1
            end
         end
      end
      
      if pad:circle() and not option.clavier then
         while pad:circle() do
            pad= Controls.read()
         end
         do
            local point= false
            for i= 1, string.len(statut.val[1]) do
               if string.sub(statut.val[1], i, i)=="." then
                  point= true
               end
            end
            if not point then
               System.createDirectory(statut.val[1])
            elseif point then
               System.rename(fichiers[yselectionneur+n_liste].name, statut.val[1])
            end
         end
         fichiers= Explorer(fichiers)
      end
      
      if pad:start() and not oldpad:start() then
         if option.clavier then
            option.clavier= false
         else
            option.clavier= true
         end
      end
      screen.waitVblankStart()
      screen.flip()
      oldpad= pad
   end
end
