Help= {
   {--:
      {
         "Font:setCharSize(number width, number height, number dpiX, number dpiY)",
         "Font",
         "=N=L=Changes the size of the current font to the specified point size height and width (if width is 0, it will be calculated proportional to the height for every character). dpiX and dpiY is the resolution of the display (see the Freetype documentation for details)."
      },
      {
         "Font:setPixelSizes(number width, number height)",
         "Font",
         "=N=L=Changes the size of the current font to the specified pixel size height and width (if width is 0, it will be calculated proportional to the height for every character). (see the Freetype documentation for details)."
      },
      {
         "Font:getTextSize(string)",
         "Width, Height",
         "=N=L=Returns the width and height, which will be used, if the specified text is drawn with this font and the current font size."
      },
      {
         "image:blit(x, y, Image source, [sourcex, sourcey, width, height], [alpha = true])",
         "nil",
         "=N=L=Paints the image, which is specified as 'source' to the image on which this function is called on (or to the double buffered screen, when using the 'screen:blit(...)' variable, which is a special image). 'sourcex' and 'sourcey' is the position in the source image, from where a rectangle of the size width/height is copied."
      },
      {
         "image:clear([color = transparent-black])",
         "nil",
         "=N=L=Sets all pixels of an image to the specified color."
      },
      {
         "image:fillRect(x, y, width, height, [color = transparent-black])",
         "nil",
         "=N=L=Draws a filled rectangle."
      },
      {
         "image:drawLine(x0, y0, x1, y1, [color = black])",
         "nil",
         "=N=L=Draws a line between coordinates (x0, y0) and (x1, y1)."
      },
      {
         "Image:pixel(x, y) ",
         "Color",
         "=N=L=Gets the color of a pixel. See for example this code to get the color of an pixel and assert the value of all color components: =N=L=image = Image.createEmpty(1, 1)=N=L=color = image:pixel(0, 0)=N=L=colors = color:colors()=N=L=assert(colors.r == 0)=N=L=assert(colors.g == 0)=N=L=assert(colors.b == 0)=N=L=assert(colors.a == 0)"
      },
      {
         "image:pixel(x, y, color) ",
         "nil",
         "=N=L=Sets the color of a pixel."
      },
      {
         "image:print(x, y, text, [color = black])",
         "nil",
         "=N=L=Prints some text with a predefined fixed width font =N=L=with 8x8 pixels per character."
      },
      {
         "image:fontPrint(Font, x, y, text, [color = black])",
         "nil",
         "=N=L=Prints some text with the specified true type font."
      },
      {
         "image:width()",
         "Number",
         "=N=L=Returns the width of an image."
      },
      {
         "image:height()",
         "Number",
         "=N=L=Returns the height of an image."
      },
      {
         "Image:save(filename)",
         "nil",
         "=N=L=Saves an image to memory stick. Currently JPEG and PNG files are supported."
      },
      {
         "color:colors()",
         "table[r, g, b, a]",
         "=N=L=Returns the RGBA values of a color object."
      },
      {
         "controls:select()",
         "Bool",
         "=N=L=Returns true if select key pressed, else returns false."
      },
      {
         "controls:start()",
         "Bool",
         "=N=L=Returns true if start key pressed, else returns false."
      },
      {
         "controls:up()",
         "Bool",
         "=N=L=Returns true if up key pressed, else returns false."
      },
      {
         "controls:right()",
         "Bool",
         "=N=L=Returns true if right key pressed, else returns false."
      },
      {
         "controls:down()",
         "Bool",
         "=N=L=Returns true if down key pressed, else returns false."
      },
      {
         "controls:left()",
         "Bool",
         "=N=L=Returns true if left key pressed, else returns false."
      },
      {
         "controls:l()",
         "Bool",
         "=N=L=Returns true if L key pressed, else returns false."
      },
      {
         "controls:r()",
         "Bool",
         "=N=L=Returns true if R key pressed, else returns false."
      },
      {
         "controls:triangle()",
         "Bool",
         "=N=L=Returns true if triangle key pressed, else returns false."
      },
      {
         "controls:circle()",
         "Bool",
         "=N=L=Returns true if circle key pressed, else returns false."
      },
      {
         "controls:cross()",
         "Bool",
         "=N=L=Returns true if cross key pressed, else returns false."
      },
      {
         "controls:square()",
         "Bool",
         "=N=L=Returns true if square key pressed, else returns false."
      },
      {
         "controls:home()",
         "Bool",
         "=N=L=Returns true if home key pressed, else returns false."
      },
      {
         "controls:hold()",
         "Bool",
         "=N=L=Returns true if hold key pressed, else returns false."
      },
      {
         "controls:note()",
         "Bool",
         "=N=L=Returns true if note key pressed, else returns false."
      },
      {
         "pad:analogX() ",
         "Number",
         "=N=L=Ranges from -127 to 128. =N=L=Returns the current analog stick position in X direction."
      },
      {
         "pad:analogY() ",
         "Number",
         "=N=L=Ranges from -127 to 128. =N=L=Returns the current analog stick position in Y direction."
      },
      {
         "controls:buttons() ",--??
         "Number",
         "=N=L=Returns the bitmask like sceCtrlReadBufferPositive reads it =N=L=Constants for binary operations on buttons() result. (for example Controls.read():buttons() & Controls.startMask > 0 is the same as Controls.read():start())"
      },
      {
         "Timer:start()",
         "Number",
         "=N=L=Starts to tick the timer (incrementing by one every millisecond), or resumes to tick after being stopped. Returns the current time() value. If the timer is running, it is the same as time()."
      },
      {
         "Timer:time()",
         "Number",
         "=N=L=Returns in milliseconds since the timer started/resumed."
      },
      {
         "Timer:stop()",
         "Number",
         "=N=L=Stops the timer. Returns the current time(). Subsequent time() calls returns the value when stopped. If the timer is stopped, this call is the same as time()."
      },
      {
         "Timer:reset([startTime])",
         "Number",
         "=N=L=Resets the timer to 0 by default or startTime in milliseconds and holds the timer. Returns the time before resetted to the new value."
      },
      {
         "sound:play()",
         "Voice",
         "=N=L=Starts the sound loaded by Sound.load()."
      },
      {
         "voice:stop()",
         "nil",
         "=N=L=Stops the sound loaded by Sound.load()"
      },
      {
         "voice:resume(Sound) ",
         "nil",
         "=N=L=DISABLED due to bug."
      },
      {
         "voice:volume( number [0-25] )",
         "nil",
         "=N=L=Adjusts the volume of the sound."
      },
      {
         "voice:pan( number [0-255] )",
         "nil",
         "=N=L=Pans the sound left or right. (128 is the middle)"
      },
      {
         "voice:frequency( number [0-255] )",
         "nil",
         "=N=L=Manages the frequency of the sound."
      },
      {
         "voice:playing()",
         "Bool",
         "=N=L=Returns true or false whether a sound is being played."
      },
      {
         "Socket:isConnected()",
         "Bool",
         "=N=L=Returns true, when the connection is established. Now recv and send can be called on this socket object."
      },
      {
         "Socket:createServerSocket(port)",
         "Socket",
         "=N=L=Creates a server socket, which listens on the specified port for incoming connections."
      },
      {
         "Socket:accept()",
         "Socket",
         "=N=L=Can be called for server sockets and returns a new incoming connection socket or nil, if no incoming connection is waiting."
      },
      {
         "Socket:recv()",
         "String",
         "=N=L=Reads and returns all available data from the socket or returns an empty string, if no data is available."
      },
      {
         "Socket:send(string)",
         "Number",
         "=N=L=Sends a string. The result is the number of bytes which was sent (which can be less than the length of the string) or less than 0, if an error occured."
      },
      {
         "Socket:close()",
         "nil",
         "=N=L=Closes a socket."
      },
      {
         "file:close()",
         "",
         "=N=L=Closes file. Note that files are automatically closed =N=L=when their handles are garbage collected, but that =N=L=takes an unpredictable amount of time to happen. "
      },
      {
         "file:flush()",
         "",
         "=N=L=Saves any written data to file."
      },
      {
         "file:lines()",
         "Iterative Function",
         "=N=L=Returns an iterator function that, each time it is =N=L=called, returns a new line from the file. Therefore, =N=L=the construction =N=L=     for line in file:lines() do body end=N=L=will iterate over all lines of the file. (Unlike io.lines, =N=L=this function does not close the file when the loop =N=L=ends.) "
      },
      {
         "file:read(...)",
         "String ou Number",
         "=N=L=Reads the file file, according to the given formats, =N=L=which specify what to read. For each format, the =N=L=function returns a string (or a number) with the =N=L=characters read, or nil if it cannot read data with =N=L=the specified format. When called without formats, it =N=L=uses a default format that reads the entire next line =N=L=(see below). =N=L=The available formats are =N=L='*n': reads a number; this is the only format that =N=L=returns a number instead of a string. =N=L='*a': reads the whole file, starting at the current =N=L=position. On end of file, it returns the empty string. =N=L='*l': reads the next line (skipping the end of line), =N=L=returning nil on end of file. This is the default format. =N=L=number: reads a string with up to this number of =N=L=characters, returning nil on end of file. If number is =N=L=zero, it reads nothing and returns an empty string, or =N=L=nil on end of file."
      },
      {
         "file:seek([whence] [, offset])",
         "Number",
         "=N=L=Sets and gets the file position, measured from the =N=L=beginning of the file, to the position given by offset =N=L=plus a base specified by the string whence, as follows: =N=L='set': base is position 0 (beginning of the file); =N=L='cur': base is current position; =N=L='end': base is end of file; =N=L=In case of success, function seek returns the final file =N=L=position, measured in bytes from the beginning of the =N=L=file. If this function fails, it returns nil, plus a =N=L=string describing the error. =N=L=The default value for whence is 'cur', and for offset is =N=L=0. Therefore, the call file:seek() returns the current =N=L=file position, without changing it; the call =N=L=file:seek('set') sets the position to the beginning of =N=L=the file (and returns 0); and the call file:seek('end') =N=L=sets the position to the end of the file, and returns =N=L=its size. "
      },
      {
         "file:setvbuf(mode [, size])",
         "",
         "=N=L=Sets the buffering mode for an output file. There are =N=L=three available modes: =N=L='no': no buffering; the result of any output operation =N=L=appears immediately. =N=L='full': full buffering; output operation is performed =N=L=only when the buffer is full (or when you explicitly =N=L=flush the file (see io.flush)). =N=L='line': line buffering; output is buffered until a =N=L=newline is output or there is any input from some =N=L=special files (such as a terminal device). =N=L=For the last two cases, sizes specifies the size of the =N=L=buffer, in bytes. The default is an appropriate size. "
      },
      {
         "file:write(...)",
         "",
         "=N=L=Writes the value of each of its arguments to the file. =N=L=The arguments must be strings or numbers. To write other =N=L=values, use tostring or string.format before write. "
      }
   },
   {--;
   },
   {--<
   },
   {--=
   },
   {-->
   },
   {--?
   },
   {--@
   },
   {--A
      {
         "assert(v [, message])",
         "",
         "=N=L=Issues an error when the value of its argument v is false (i.e., nil or false); otherwise, returns all its arguments. message is an error message; when absent, it defaults to 'assertion failed!' "
      }
   },
   {--B
   },
   {--C
      {
         "Color.new(r, g, b, [a =255])",
         "Color",
         "=N=L=Creates a new color object with the specified RGBA values."
      },
      {
         "Controls.read()",
         "Bool",
         "=N=L=Reads the keyboard buffer. =N=L=For example, to read if the [start] is pressed:=N=L=Controls.read():start() =N=L=returns true if the key is pressed."
      },
      {
         "Controls.selectMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [select]. =N=L=Use control:buttons()"
      },
      {
         "Controls.startMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [start]. =N=L=Use control:buttons()"
      },
      {
         "Controls.upMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [up]. =N=L=Use control:buttons()"
      },
      {
         "Controls.rightMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [right]. =N=L=Use control:buttons()"
      },
      {
         "Controls.downMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [down]. =N=L=Use control:buttons()"
      },
      {
         "Controls.leftMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [left]. =N=L=Use control:buttons()"
      },
      {
         "Controls.ltriggerMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [LT]. =N=L=Use control:buttons()"
      },
      {
         "Controls.rtriggerMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [RT]. =N=L=Use control:buttons()"
      },
      {
         "Controls.triangleMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [triangle]. =N=L=Use control:buttons()"
      },
      {
         "Controls.circleMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [circle]. =N=L=Use control:buttons()"
      },
      {
         "Controls.crossMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [cross]. =N=L=Use control:buttons()"
      },
      {
         "Controls.squareMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [square]. =N=L=Use control:buttons()"
      },
      {
         "Controls.homeMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [Home]. =N=L=Use control:buttons()"
      },
      {
         "Controls.holdMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [hold]. =N=L=Use control:buttons()"
      },
      {
         "Controls.noteMask",
         "Number",
         "=N=L=(This is not a function). =N=L=Mask used to access [note]. =N=L=Use control:buttons()"
      },
      {
         "collectgarbage(opt [, arg])",
         "",
         "=N=L=This function is a generic interface to the garbage collector. It performs different functions according to its first argument, opt: =N=L='stop': stops the garbage collector. =N=L='restart': restarts the garbage collector. =N=L='collect': performs a full garbage-collection cycle. =N=L='count': returns the total memory in use by Lua (in Kb). =N=L='step': performs a garbage-collection step. The step 'size' is controlled by arg (larger values mean more steps) in a non-specified way. If you want to control the step size you must experimentally tune the value of arg. Returns true if the step finished a collection cycle. =N=L='setpause': sets arg/100 as the new value for the pause of the collector. =N=L='setstepmul': sets arg/100 as the new value for the step multiplier of the collector. "
      },
      {
         "coroutine.create(f)",
         "Thread",
         "=N=L=Creates a new coroutine, with body f.  f must be a Lua function. =N=L=Returns this new coroutine, an object with type 'thread'. "
      },
      {
         "coroutine.resume(co [, val1, ...])",
         "",
         "=N=L=Starts or continues the execution of coroutine co. The first time you resume a coroutine, it starts running its body. The values val1, ... are passed as the arguments to the body function. If the coroutine has yielded, resume restarts it; the values val1, ... are passed as the results from the yield. =N=L=If the coroutine runs without any errors, resume returns true plus any values passed to yield (if the coroutine yields) or any values returned by the body function (if the coroutine terminates). If there is any error, resume returns false plus the error message. "
      },
      {
         "coroutine.running()",
         "",
         "=N=L=Returns the running coroutine, or nil when called by the main thread. "
      },
      {
         "coroutine.status(co)",
         "String",
         "=N=L=Returns the status of coroutine co, as a string: 'running', if the coroutine is running (that is, it called status); 'suspended', if the coroutine is suspended in a call to yield, or if it has not started running yet; 'normal' if the coroutine is active but not running (that is, it has resumed another coroutine); and 'dead' if the coroutine has finished its body function, or if it has stopped with an error. "
      },
      {
         "coroutine.wrap(f)",
         "",
         "=N=L=Creates a new coroutine, with body f. f must be a Lua function. Returns a function that resumes the coroutine each time it is called. Any arguments passed to the function behave as the extra arguments to resume. Returns the same values returned by resume, except the first boolean. In case of error, propagates the error. "
      },
      {
         "coroutine.yield(...)",
         "",
         "=N=L=Suspends the execution of the calling coroutine. The coroutine cannot be running a C function, a metamethod, or an iterator. Any arguments to yield are passed as extra results to resume. "
      }
   },
   {--D
      {
         "dofile(filename)",
         "",
         "=N=L=Opens the named file and executes its contents as a Lua chunk. When called without arguments, dofile executes the contents of the standard input (stdin). Returns all values returned by the chunk. In case of errors, dofile propagates the error to its caller (that is, dofile does not run in protected mode). "
      },
      {
         "debug.debug()",
         "",
         "=N=L=Enters an interactive mode with the user, running each string that the user enters. Using simple commands and other debug facilities, the user can inspect global and local variables, change their values, evaluate expressions, and so on. A line containing only the word cont finishes this function, so that the caller continues its execution. =N=L=Note that commands for debug.debug are not lexically nested within any function, and so have no direct access to local variables. "
      },
      {
         "debug.getfenv(o)",
         "",
       "=N=L=Returns the environment of object o. "
      },
      {
         "debug.gethook([thread])",
         "",
       "=N=L=Returns the current hook settings of the thread, as three values: the current hook function, the current hook mask, and the current hook count (as set by the debug.sethook function). "
      },
      {
         "debug.getinfo([thread,] function [, what])",
         "",
         "=N=L=Returns a table with information about a function. You can give the function directly, or you can give a number as the value of function, which means the function running at level function of the call stack of the given thread: level 0 is the current function (getinfo itself); level 1 is the function that called getinfo; and so on. If function is a number larger than the number of active functions, then getinfo returns nil. =N=L=The returned table may contain all the fields returned by lua_getinfo, with the string what describing which fields to fill in. The default for what is to get all information available, except the table of valid lines. If present, the option 'f' adds a field named func with the function itself. If present, the option 'L' adds a field named activelines with the table of valid lines. =N=L=For instance, the expression debug.getinfo(1,'n').name returns a name of the current function, if a reasonable name can be found, and debug.getinfo(print) returns a table with all available information about the print function. "
      },
      {
         "debug.getlocal([thread,] level, local)",
         "",
       "=N=L=This function returns the name and the value of the local variable with index local of the function at level level of the stack. (The first parameter or local variable has index 1, and so on, until the last active local variable.) The function returns nil if there is no local variable with the given index, and raises an error when called with a level out of range. (You can call debug.getinfo to check whether the level is valid.) =N=L=Variable names starting with '(' (open parentheses) represent internal variables (loop control variables, temporaries, and C function locals). "
      },
      {
         "debug.getmetatable(object)",
         "",
         "=N=L=Returns the metatable of the given object or nil if it does not have a metatable. "
      },
      {
         "debug.getregistry()",
         "",
         "=N=L=Returns the registry table. "
      },
      {
         "debug.getupvalue(func, up)",
         "",
         "=N=L=This function returns the name and the value of the upvalue with index up of the function func. The function returns nil if there is no upvalue with the given index. "
      },
      {
         "debug.setfenv(object, table)",
         "Object",
         "=N=L=Sets the environment of the given object to the given table. Returns object. "
      },
      {
         "debug.sethook([thread,] hook, mask [, count])",
         "",
         "=N=L=Sets the given function as a hook. The string mask and the number count describe when the hook will be called. The string mask may have the following characters, with the given meaning: =N=L='c': The hook is called every time Lua calls a function; =N=L='r': The hook is called every time Lua returns from a function; =N=L='l': The hook is called every time Lua enters a new line of code. =N=L=With a count different from zero, the hook is called after every count instructions. =N=L=When called without arguments, debug.sethook turns off the hook. =N=L=When the hook is called, its first parameter is a string describing the event that has triggered its call: 'call', 'return' (or 'tail return'), 'line', and 'count'. For line events, the hook also gets the new line number as its second parameter. Inside a hook, you can call getinfo with level 2 to get more information about the running function (level 0 is the getinfo function, and level 1 is the hook function), unless the event is 'tail return'. In this case, Lua is only simulating the return, and a call to getinfo will return invalid data. "
      },
      {
         "debug.setlocal([thread,] level, local, value)",
         "",
         "=N=L=This function assigns the value value to the local variable with index local of the function at level level of the stack. The function returns nil if there is no local variable with the given index, and raises an error when called with a level out of range. (You can call getinfo to check whether the level is valid.) Otherwise, it returns the name of the local variable. "
      }
   },
   {--E
      {
         "error(message [, level])",
         "",
         "=N=L=Terminates the last protected function called and returns message as the error message. Function error never returns. =N=L=Usually, error adds some information about the error position at the beginning of the message. The level argument specifies how to get the error position. With level 1 (the default), the error position is where the error function was called. Level 2 points the error to where the function that called error was called; and so on. Passing a level 0 avoids the addition of error position information to the message. "
      }
   },
   {--F
      {
         "Font.load(filename)",
         "Font",
         "=N=L=Load a TrueType font."
      },
      {
         "Font.createMonoSpaced()",
         "Font",
         "=N=L=Creates a monospaced font."
      },
      {
         "Font.createProportional()",
         "Font",
         "=N=L=Creates a proportional font."
      }
   },
   {--G
      {
         "Gu.start3d()",
         "",
         "=N=L=Saves the current GE state for the normal 2D operations. Call this function first and then draw your scene. You can use the following functions: =N=L=Gu.clearColor, Gu.clearDepth, Gu.clear, Gum.matrixMode, Gum.loadIdentity, Gum.perspective, Gum.translate, Gum.rotateXYZ, Gu.texImage, Gu.texFunc, Gu.texEnvColor, Gu.texFilter, Gu.texScale, Gu.texOffset, Gu.ambientColor, Gu.enable, Gu.disable, Gu.blendFunc, Gu.light, Gu.lightAtt, Gu.lightColor, Gu.lightMode, Gu.lightSpot and Gum.drawArray. =N=L=See the PSPSDK for documenation about the parameters, for example the pspgu.h. If there is a ScePspFVector3, write 3 numbers instead one parameter (this will be changed in a later version). Whereever a color is expected, use a Color object. For textures use an Image object. =N=L=Gum.drawArray is something special: It has just 3 parameters: 'prim', 'vtype' and a table. With 'prim' you specify which primitive should be used, for example Gu.TRIANGLES. 'vtype' specifies the vertex format and the transformation operation. For example 'Gu.COLOR_8888|Gu.VERTEX_32BITF|Gu.TRANSFORM_3D' means, that your vertices has a color component and a 3 vertex coordinate components and is transformed before passed to the rasterizer. The table is then a list of vertex entries, where each vertex entry has the form (color, x, y, z). If you have specified GU_TEXTURE_32BITF, too, then one entry looks like this: (textureU, textureV, color, x, y, z). The order of the entries is defined in pspgu.h: textureU, textureV, color, normalX, normalY, normalZ, vertexX, vertexY, vertexZ. Indices, weights and multiple vertices per entry (which youll need for the morphing feature) currently are not supported. =N=L=After drawing anything, call Gu.end3d(), which flushs the display buffer and draws all pending 3D graphics and restores the 2D GE state. Dont forget to call a screen:clear() before fullscreen 2D operations, because otherwise the z-buffer is not cleared and the blitting functions may not work correctly. If you need to blit 2D images in 3D mode, use textures and triangles. =N=L=See the 3D Cube example in the Applications folder of the distribution of Lua Player to see how to use the 3D functions and take a look at the GU example in the PSPSDK how to use all the other functions. Most of the time you can copy and paste the examples and just remove all those C fussinesses like '.0f', semicolon, malloc, etc."
      },
      {
         "Gu.clearColor()",
         "",
         ""
      },
      {
         "Gu.clearDepth()",
         "",
         ""
      },
      {
         "Gu.clear()",
         "",
         ""
      },
      {
         "Gum.matrixMode()",
         "",
         ""
      },
      {
         "Gum.loadIdentity()",
         "",
         ""
      },
      {
         "Gum.perspective()",
         "",
         ""
      },
      {
         "Gum.translate()",
         "",
         ""
      },
      {
         "Gum.rotateXYZ()",
         "",
         ""
      },
      {
         "Gu.texImage()",
         "",
         ""
      },
      {
         "Gu.texFunc()",
         "",
         ""
      },
      {
         "Gu.texEnvColor()",
         "",
         ""
      },
      {
         "Gu.texFilter()",
         "",
         ""
      },
      {
         "Gu.texScale()",
         "",
         ""
      },
      {
         "Gu.texOffset()",
         "",
         ""
      },
      {
         "Gu.ambientColor()",
         "",
         ""
      },
      {
         "Gu.enable()",
         "",
         ""
      },
      {
         "Gu.disable()",
         "",
         ""
      },
      {
         "Gu.blendFunc()",
         "",
         ""
      },
      {
         "Gu.light()",
         "",
         ""
      },
      {
         "Gu.lightAtt()",
         "",
         ""
      },
      {
         "Gu.lightColor()",
         "",
         ""
      },
      {
         "Gu.lightMode()",
         "",
         ""
      },
      {
         "Gu.lightSpot()",
         "",
         ""
      },
      {
         "getfenv(f)",
         "",
         "=N=L=Returns the current environment in use by the function. f can be a Lua function or a number that specifies the function at that stack level: Level 1 is the function calling getfenv. If the given function is not a Lua function, or if f is 0, getfenv returns the global environment. The default for f is 1. "
      },
      {
         "getmetatable(object)",
         "",
         "=N=L=If object does not have a metatable, returns nil. Otherwise, if the object's metatable has a '__metatable' field, returns the associated value. Otherwise, returns the metatable of the given object. "
      }
   },
   {--H
   },
   {--I
      {
         "Image.createEmpty(Width, Height)",
         "Image",
         "=N=L=Creates an empty image, initially cleared. Max width and height is 512"
      },
      {
         "Image.load(filename)",
         "Image",
         "=N=L=Loads an image. Currently only JPEG and PNG are supported."
      },
      {
         "ipairs(t)",
         "",
         "=N=L=Iterates over the elements contained in an array. =N=L=Provides the next indexed key, in ascending order, each time it is called. =N=L=Returns three values: an iterator function, the table t, and 0, =N=L=so that the construction for i,v in 'ipairs(t) do body end'=N=L=will iterate over the pairs (1,t[1]), (2,t[2]), ..., up to the first integer key absent from the table."
      },
      {
         "io.close([file])",
         "",
         "=N=L=Equivalent to file:close(). Without a file, closes the =N=L=default output file. "
      },
      {
         "io.flush()",
         "",
         "=N=L=Equivalent to file:flush over the default output file. "
      },
      {
         "io.input([file])",
         "",
         "=N=L=When called with a file name, it opens the named file =N=L=(in text mode), and sets its handle as the default input =N=L=file. When called with a file handle, it simply sets =N=L=this file handle as the default input file. When called =N=L=without parameters, it returns the current default input =N=L=file. =N=L=In case of errors this function raises the error, =N=L=instead of returning an error code. "
      },
      {
         "io.lines([filename])",
         "",
         "=N=L=Opens the given file name in read mode and returns an =N=L=iterator function that, each time it is called, returns =N=L=a new line from the file. Therefore, the construction =N=L=     for line in io.lines(filename) do body end=N=L=will iterate over all lines of the file. When the =N=L=iterator function detects the end of file, it returns =N=L=nil(to finish the loop) and automatically closes the =N=L=file. =N=L=The call io.lines() (without a file name) is equivalent =N=L=to io.input():lines(); that is, it iterates over the =N=L=lines of the default input file. In this case it does =N=L=not close the file when the loop ends. "
      },
      {
         "io.open(filename [, mode])",
         "",
         "=N=L=This function opens a file, in the mode specified in the =N=L=string mode. It returns a new file handle, or, in case =N=L=of errors, nil plus an error message. =N=L=The mode string can be any of the following: =N=L='r': read mode (the default); =N=L='w': write mode; =N=L='a': append mode; =N=L='r+': update mode, all previous data is preserved; =N=L='w+': update mode, all previous data is erased; =N=L='a+': append update mode, previous data is preserved, =N=L=writing is only allowed at the end of file. =N=L=The mode string may also have a 'b' at the end, which is =N=L=needed in some systems to open the file in binary mode. This string is exactly what is used in the standard C function fopen. "
      },
      {
         "io.output([file])",
         "",
       "=N=L=Similar to io.input, but operates over the default =N=L=output file. "
      },
      {
         "io.popen([prog [, mode]])",
         "",
       "=N=L=Starts program prog in a separated process and returns a =N=L=file handle that you can use to read data from this =N=L=program(if mode is 'r', the default) or to write data =N=L=to this program (if mode is 'w'). =N=L=This function is system dependent and is not available =N=L=on all platforms. "
      },
      {
         "io.read(...)",
         "",
         "=N=L=Equivalent to io.input():read. "
      },
      {
         "io.tmpfile()",
         "",
       "=N=L=Returns a handle for a temporary file. This file is =N=L=opened in update mode and it is automatically removed =N=L=when the program ends. "
      },
      {
         "io.type(obj)",
         "",
         "=N=L=Checks whether obj is a valid file handle. Returns the =N=L=string 'file' if obj is an open file handle, 'closed =N=L=file' if obj is a closed file handle, or nil if obj is =N=L=not a file handle. "
      },
      {
         "io.write(...)",
         "",
       "=N=L=Equivalent to io.output():write. "
      }
   },
   {--J
   },
   {--K
   },
   {--L
      {
         "load(func [, chunkname])",
         "",
       "=N=L=Loads a chunk using function func to get its pieces. Each call to func must return a string that concatenates with previous results. A return of nil (or no value) signals the end of the chunk. If there are no errors, returns the compiled chunk as a function; otherwise, returns nil plus the error message. The environment of the returned function is the global environment. chunkname is used as the chunk name for error messages and debug information. "
      },
      {
         "loadfile([filename])",
         "",
         "=N=L=Similar to load, but gets the chunk from file filename or from the standard input, if no file name is given. "
      },
      {
         "loadstring(string [, chunkname])",
         "",
       "=N=L=Similar to load, but gets the chunk from the given string. To load and run a given string, use the idiom =N=L=     assert(loadstring(s))"
      }
   },
   {--M
      {
         "Music.playFile( string file, bool loop )",
         "nil",
         "=N=L=Plays a music file in one of the following formats: UNI, IT, XM, S3M, MOD, MTM,=N=L=STM, DSM, MED, FAR, ULT or 669."
      },
      {
         "Music.resume()",
         "nil",
         ""
      },
      {
         "Music.stop()",
         "nil",
         ""
      },
      {
         "Music.playing()",
         "Bool",
         ""
      },
      {
         "Music.volume( [number {0-128}] )",
         "Number",
         ""
      },
      {
         "math.abs(x)",
         "Number",
       "=N=L=Returns the absolute value of x. "
      },
      {
         "math.acos(x)",
         "Number",
         "=N=L=Returns the arc cosine of x (in radians). "
      },
      {
         "math.asin(x)",
         "Number",
         "=N=L=Returns the arc sine of x (in radians). "
      },
      {
         "math.atan(x)",
         "Number",
         "=N=L=Returns the arc tangent of x (in radians). "
      },
      {
         "math.atan2(x, y)",--??
         "Number",
         "=N=L=Returns the arc tangent of x/y (in radians), but uses the signs of both parameters to find the quadrant of the result. (It also handles correctly the case of y being zero.) "
      },
      {
         "math.ceil(x)",
         "Number",
         "=N=L=Returns the smallest integer larger than or equal to x. "
      },
      {
         "math.cos(x)",
         "Number",
         "=N=L=Returns the cosine of x (assumed to be in radians). "
      },
      {
         "math.cosh(x)",
         "Number",
       "=N=L=Returns the hyperbolic cosine of x. "
      },
      {
         "math.deg(x)",
         "Number",
       "=N=L=Returns the angle x (given in radians) in degrees. "
      },
      {
         "math.exp(x)",
         "Number",
       "=N=L=Returns the the value ex. "
      },
      {
         "math.floor(x)",
         "Number",
       "=N=L=Returns the largest integer smaller than or equal to x. "
      },
      {
         "math.fmod(x, y)",
         "Number",
       "=N=L=Returns the remainder of the division of x by y. "
      },
      {
         "math.frexp(x)",
         "Number",
       "=N=L=Returns m and e such that x = m2e, e is an integer and the absolute value of m is in the range (0.5, 1) (or zero when x is zero). "
      },
      {
         "math.huge",
         "Number",
       "=N=L=The value HUGE_VAL, a value larger than or equal to any other numerical value. "
      },
      {
         "math.ldexp(m, e)",
         "Number",
         "=N=L=Returns m2e (e should be an integer). "
      },
      {
         "math.log(x)",
         "Number",
         "=N=L=Returns the natural logarithm of x. "
      },
      {
         "math.log10(x)",
         "Number",
       "=N=L=Returns the base-10 logarithm of x. "
      },
      {
         "math.max(x, ...)",
         "Number",
       "=N=L=Returns the maximum value among its arguments. "
      },
      {
         "math.min(x, ...)",
         "Number",
       "=N=L=Returns the minimum value among its arguments. "
      },
      {
         "math.modf(x)",
         "Number",
       "=N=L=Returns two numbers, the integral part of x and the fractional part of x. "
      },
      {
         "math.pi",
         "Number",
       "=N=L=The value PI. "
      },
      {
         "math.pow(x, y)",
         "Number",
       "=N=L=Returns xy. (You can also use the expression x^y to compute this value.) "
      },
      {
         "math.rad(x)",
         "Number",
       "=N=L=Returns the angle x (given in degrees) in radians. "
      },
      {
         "math.random([m [, n]])",
         "Number",
         "=N=L=This function is an interface to the simple pseudo-random generator function rand provided by ANSI C. (No guarantees can be given for its statistical properties.) When called without arguments, returns a pseudo-random real number in the range [0,1). When called with a number m, math.random returns a pseudo-random integer in the range [1, m]. When called with two numbers m and n, math.random returns a pseudo-random integer in the range [m, n]. "
      },
      {
         "math.randomseed(x)",
         "",
       "=N=L=Sets x as the 'seed' for the pseudo-random generator: equal seeds produce equal sequences of numbers. "
      },
      {
         "math.sin(x)",
         "Number",
       "=N=L=Returns the sine of x (assumed to be in radians). "
      },
      {
         "math.sinh(x)",
         "Number",
       "=N=L=Returns the hyperbolic sine of x. "
      },
      {
         "math.sqrt(x)",
         "Number",
       "=N=L=Returns the square root of x. (You can also use the expression x^0.5 to compute this value.) "
      },
      {
         "math.tan(x)",
         "Number",
       "=N=L=Returns the tangent of x (assumed to be in radians). "
      },
      {
         "math.tanh(x)",
         "Number",
       "=N=L=Returns the hyperbolic tangent of x. "
      },
      {
         "module(name [, ...])",--??
         "",
         "=N=L=Creates a module. If there is a table in package.loaded[name], this table is the module. Otherwise, if there is a global table t with the given name, this table is the module. Otherwise creates a new table t and sets it as the value of the global name and the value of package.loaded[name]. This function also initializes t._NAME with the given name, t._M with the module (t itself), and t._PACKAGE with the package name (the full module name minus last component; see below). Finally, module sets t as the new environment of the current function and the new value of package.loaded[name], so that require returns t. =N=L=If name is a compound name (that is, one with components separated by dots), module creates (or reuses, if they already exist) tables for each component. For instance, if name is a.b.c, then module stores the module table in field c of field b of global a. =N=L=This function may receive optional options after the module name, where each option is a function to be applied over the module. "
      }
   },
   {--N
      {
         "Music.pause()",
         "nil",
         ""
      },
      {
         "next(table [, index])",
         "",
         "=N=L=Allows a program to traverse all fields of a table. Its first argument is a table and its second argument is an index in this table. next returns the next index of the table and its associated value. When called with nil as its second argument, next returns an initial index and its associated value. When called with the last index, or with nil in an empty table, next returns nil. If the second argument is absent, then it is interpreted as nil. In particular, you can use next(t) to check whether a table is empty. The order in which the indices are enumerated is not specified, even for numeric indices. (To traverse a table in numeric order, use a numerical for or the ipairs function.) The behavior of next is undefined if, during the traversal, you assign any value to a non-existent field in the table. You may however modify existing fields. In particular, you may clear existing fields. "
      }
   },
   {--O
      {
         "os.clock()",
         "",
         "=N=L=Returns an approximation of the amount in seconds of CPU time used by the program. "
      },
      {
         "os.date([format [, time]])",
         "",
         "=N=L=Returns a string or a table containing date and time, formatted according to the given string format. =N=L=If the time argument is present, this is the time to be formatted. =N=L=(see the os.time function for a description of this value)=N=L=Otherwise, date formats the current time. =N=L=If format starts with '!', then the date is formatted in Coordinated Universal Time. After this optional character, if format is *t, then date returns a table with the following fields: year (four digits), month (1--12), day (1--31), hour (0--23), min (0--59), sec (0--61), wday (weekday, Sunday is 1), yday (day of the year), and isdst (daylight saving flag, a boolean). =N=L=If format is not *t, then date returns the date as a string, formatted according to the same rules as the C function strftime. =N=L=When called without arguments, date returns a reasonable date and time representation that depends on the host system and on the current locale (that is, os.date() is equivalent to os.date('%c')). "
      },
      {
         "os.difftime(t2, t1)",
         "",
         "=N=L=Returns the number of seconds from time t1 to time t2. In POSIX, Windows, and some other systems, this value is exactly t2-t1. "
      },
      {
         "os.execute([command])",
         "",
         "=N=L=This function is equivalent to the C function system. It passes command to be executed by an operating system shell. It returns a status code, which is system-dependent. If command is absent, then it returns nonzero if a shell is available and zero otherwise. "
      },
      {
         "os.exit([code])",
         "",
         "=N=L=Calls the C function exit, with an optional code, to terminate the host program. The default value for code is the success code. "
      },
      {
         "os.getenv(varname)",
         "",
         "=N=L=Returns the value of the process environment variable varname, or nil if the variable is not defined. "
      },
      {
         "os.remove(filename)",
         "",
         "=N=L=Deletes the file or directory with the given name. Directories must be empty to be removed. If this function fails, it returns nil, plus a string describing the error. "
      },
      {
         "os.rename(oldname, newname)",
         "",
         "=N=L=Renames file or directory named oldname to newname. If this function fails, it returns nil, plus a string describing the error. "
      },
      {
         "os.setlocale(locale [, category])",
         "",
         "=N=L=Sets the current locale of the program. locale is a string specifying a locale; category is an optional string describing which category to change: 'all', 'collate', 'ctype', 'monetary', 'numeric', or 'time'; the default category is 'all'. The function returns the name of the new locale, or nil if the request cannot be honored. =N=L=When called with nil as the first argument, this function only returns the name of the current locale for the given category. "
      },
      {
         "os.time([table])",
         "",
         "=N=L=Returns the current time when called without arguments, or a time representing the date and time specified by the given table. This table must have fields year, month, and day, and may have fields hour, min, sec, and isdst (for a description of these fields, see the os.date function). =N=L=The returned value is a number, whose meaning depends on your system. In POSIX, Windows, and some other systems, this number counts the number of seconds since some given start time (the 'epoch'). In other systems, the meaning is not specified, and the number returned by time can be used only as an argument to date and difftime. "
      },
      {
         "os.tmpname()",
         "",
         "=N=L=Returns a string with a file name that can be used for a temporary file. The file must be explicitly opened before its use and explicitly removed when no longer needed. "
      }
   },
   {--P
      {
         "pairs(t)",
         "",
         "=N=L=Returns three values: the next function, the table t, and nil, so that the construction for k,v in =N=L=pairs(t) do =N=L=  body=N=L=end=N=L=will iterate over all keyvalue pairs of table t."
      },
      {
         "pcall(f, arg1, ...)",
         "",
         "=N=L=Calls function f with the given arguments in protected mode. This means that any error inside f is not propagated.  instead, pcall catches the error and returns a status code. Its first result is the status code (a boolean), which is true if the call succeeds without errors. In such case, pcall also returns all results from the call, after this first result. In case of any error, pcall returns false plus the error message. "
      },
      {
         "print(...)",
         "",
         "=N=L=Receives any number of arguments, and prints their values to stdout, using the tostring function to convert them to strings. print is not intended for formatted output, but only as a quick way to show a value, typically for debugging. For formatted output, use string.format. "
      },
      {
         "package.cpath",
         "",
         "=N=L=The path used by require to search for a C loader. =N=L=Lua initializes the C path package.cpath in the same way it initializes the Lua path package.path, using the environment variable LUA_CPATH (plus another default path defined in luaconf.h). "
      },
      {
         "package.loaded",
         "",
         "=N=L=A table used by require to control which modules are already loaded. When you require a module modname and package.loaded[modname] is not false, require simply returns the value stored there. "
      },
      {
         "package.loadlib(libname, funcname)",
         "",
         "=N=L=Dynamically links the host program with the C library libname. Inside this library, looks for a function funcname and returns this function as a C function. (So, funcname must follow the protocol (see lua_CFunction)). =N=L=This is a low-level function. It completely bypasses the package and module system. Unlike require, it does not perform any path searching and does not automatically adds extensions. libname must be the complete file name of the C library, including if necessary a path and extension. funcname must be the exact name exported by the C library (which may depend on the C compiler and linker used). =N=L=This function is not supported by ANSI C. As such, it is only available on some platforms (Windows, Linux, Mac OS X, Solaris, BSD, plus other Unix systems that support the dlfcn standard). "
      },
      {
         "package.path",
         "",
         "=N=L=The path used by require to search for a Lua loader. =N=L=At start-up, Lua initializes this variable with the value of the environment variable LUA_PATH or with a default path defined in luaconf.h, if the environment variable is not defined. Any ';;' in the value of the environment variable is replaced by the default path. =N=L=A path is a sequence of templates separated by semicolons. For each template, require will change each interrogation mark in the template by filename, which is modname with each dot replaced by a 'directory separator' (such as '/' in Unix); then it will try to load the resulting file name. So, for instance, if the Lua path is =N=L=     './?.lua;./?.lc;/usr/local/?/init.lua'=N=L=the search for a Lua loader for module foo will try to load the files ./foo.lua, ./foo.lc, and /usr/local/foo/init.lua, in that order. "
      },
      {
         "package.preload",
         "",
         "=N=L=A table to store loaders for specific modules.=N=L=(see require)"
      },
      {
         "package.seeall(module)",
         "",
         "=N=L=Sets a metatable for module with its __index field referring to the global environment, so that this module inherits values from the global environment. To be used as an option to function module. "
      }
   },
   {--Q
   },
   {--R
      {
         "rawequal(v1, v2)",
         "",
         "=N=L=Checks whether v1 is equal to v2, without invoking any metamethod. Returns a boolean. "
      },
      {
         "rawget(table, index)",
         "",
         "=N=L=Gets the real value of table[index], without invoking any metamethod. table must be a table; index may be any value. "
      },
      {
         "rawset(table, index, value)",
         "",
         "=N=L=Sets the real value of table[index] to value, without invoking any metamethod. table must be a table, index any value different from nil, and value any Lua value. =N=L=This function returns table. "
      },
      {
         "require(modname)",
         "",
         "=N=L=Loads the given module. The function starts by looking into the table package.loaded to determine whether modname is already loaded. If it is, then require returns the value stored at package.loaded[modname]. Otherwise, it tries to find a loader for the module. =N=L=To find a loader, first require queries package.preload[modname]. If it has a value, this value (which should be a function) is the loader. Otherwise require searches for a Lua loader using the path stored in package.path. If that also fails, it searches for a C loader using the path stored in package.cpath. If that also fails, it tries an all-in-one loader (see below). =N=L=When loading a C library, require first uses a dynamic link facility to link the application with the library. Then it tries to find a C function inside this library to be used as the loader. The name of this C function is the string 'luaopen_' concatenated with a copy of the module name where each dot is replaced by an underscore. Moreover, if the module name has a hyphen, its prefix up to (and including) the first hyphen is removed. For instance, if the module name is a.v1-b.c, the function name will be luaopen_b_c. =N=L=If require finds neither a Lua library nor a C library for a module, it calls the all-in-one loader. This loader searches the C path for a library for the root name of the given module. For instance, when requiring a.b.c, it will search for a C library for a. If found, it looks into it for an open function for the submodule; in our example, that would be luaopen_a_b_c. With this facility, a package can pack several C submodules into one single library, with each submodule keeping its original open function. =N=L=Once a loader is found, require calls the loader with a single argument, modname. If the loader returns any value, require assigns it to package.loaded[modname]. If the loader returns no value and has not assigned any value to package.loaded[modname], then require assigns true to this entry. In any case, require returns the final value of package.loaded[modname]. =N=L=If there is any error loading or running the module, or if it cannot find any loader for the module, then require signals an error. "
      }
   },
   {--S
      {
         "screen",
         "global Image",
         "=N=L=The special double buffered screen object, which has all methods of an image and some more."
      },
      {
         "screen.flip() ",
         "nil",
         "=N=L=Note the small s, this is a function of the screen.  Flips the offscreen and onscreen screen."
      },
      {
         "screen.waitVblankStart([count])",
         "nil",
         "=N=L=Waits until vertical retrace starts."
      },
      {
         "System.currentDirectory() ",
         "String ",
         "=N=L=GETS the current working directory."
      },
      {
         "System.currentDirectory( path ) ",
         "String ",
         "=N=L=SETS the current working directory."
      },
      {
         "System.listDirectory( [path] )",
         "table ",
         "=N=L=Lists the contents of the current working directory or the specified path. =N=L=The result is a table of tables, where each table-entry has the string entry 'name', the number entry 'size' and the boolean entry 'directory', which is set to true, when the current entry is a directory. =N=L=See for example this code to print all files in the current working directory: =N=L=files = System.listDirectory()=N=L=for index, file in files do=N=L=print(file.name)=N=L=end"
      },
      {
         "System.createDirectory(path)",
         "nil ",
         "=N=L=Creates a new directory. The path is relative to the current directory, if not absolute."
      },
      {
         "System.removeDirectory(path)",
         "nil ",
         "=N=L=Deletes a directory. The path is relative to the current directory, if not absolute."
      },
      {
         "System.removeFile(path)",
         "nil ",
         "=N=L=Deletes a file. The path is relative to the current directory, if not absolute."
      },
      {
         "System.rename(oldName, newName)",
         "nil ",
         "=N=L=Renames files and directories. The path is relative to the current directory, if not absolute."
      },
      {
         "System.usbDiskModeActivate()",
         "nil ",
         "=N=L=Activates the USB mode. Attention: When writing from USB to the memory stick, you must not write from within your Lua script to the memory stick, until you disable USB, otherwise the filesystem of your memory stick gets corrupted and you have to reformat your memmory stick."
      },
      {
         "System.usbDiskModeDeactivate()",
         "nil ",
         "=N=L=Deactivates the USB mode."
      },
      {
         "System.powerIsPowerOnline()",
         "Bool ",
         ""
      },
      {
         "System.powerIsBatteryExist()",
         "Bool ",
         ""
      },
      {
         "System.powerIsBatteryCharging()",
         "Bool ",
         ""
      },
      {
         "System.powerGetBatteryChargingStatus()",
         "Number ",
         ""
      },
      {
         "System.powerIsLowBattery()",
         "Bool ",
         ""
      },
      {
         "System.powerGetBatteryLifePercent()",
         "Number ",
         ""
      },
      {
         "System.powerGetBatteryLifeTime()",
         "Number ",
         ""
      },
      {
         "System.powerGetBatteryTemp()",
         "Number ",
         ""
      },
      {
         "System.powerGetBatteryVolt()",
         "Number ",
         ""
      },
      {
         "System.powerTick()",
         "Number ",
         "=N=L=When called, it resets the internal power off counter, which prevents auto power off."
      },
      {
         "System.md5sum(String)",
         "String ",
         "=N=L=Calculates the md5sum of a string. For example print(System.md5sum(io.input('EBOOT.PBP'):read('*a'))) prints the same digest as 'md5sum EBOOT.PBP' on Unix."
      },
      {
         "System.sioInit(baudrate)",
         "nil ",
         "=N=L=Opens the SIO device and sets the baud rate. This needs some seconds to power up the UART."
      },
      {
         "System.sioWrite(string)",
         "",
         "=N=L=Writes the string to the SIO"
      },
      {
         "System.sioRead()",
         "string ",
         "=N=L=Reads all available data from the SIO. Returns an empty string, if no data was received."
      },
      {
         "System.sleep(number)",
         "",
         "=N=L=Pauses program execution for the specified time in milliseconds. It doesnt affect any timer object."
      },
      {
         "System.irdaInit()",
         "nil ",
         "=N=L=Opens the IrDA device. Call this to start the IrDA module."
      },
      {
         "System.irdaWrite(string)",
         "",
         "=N=L=Writes the string to the IrDA port."
      },
      {
         "System.irdaRead()",
         "string ",
         "=N=L=Reads all available data from the IrDA port. Returns an empty string, if no data was received."
      },
      {
         "System.getFreeMemory()",
         "number ",
         "=N=L=Gets the available free memory."
      },
      {
         "SoundSystem.SFXVolume( number {0-128} )",
         "nil ",
         ""
      },
      {
         "SoundSystem.reverb( number {0-15} )",
         "nil ",
         ""
      },
      {
         "SoundSystem.panoramicSeparation( number {0-128} )",
         "nil ",
         ""
      },
      {
         "Sound.load(filename, [bool loop])",
         "Sound ",
         ""
      },
      {
         "Socket.connect(host, port)",
         "Socket ",
         "=N=L=Creates a new TCP/IP Socket object and starts the connection process to the specified host and port. All sockets are non-blocking."
      },
      {
         "string.byte(s [, i [, j]])",
         "number",
         "=N=L=Returns the internal numerical codes of the characters s[i], s[i+1], ..., s[j]. The default value for i is 1; the default value for j is i. Note that numerical codes are not necessarily portable across platforms. "
      },
      {
         "string.char(...)",
         "string",
         "=N=L=Receives zero or more integers. Returns a string with length equal to the number of arguments, in which each character has the internal numerical code equal to its corresponding argument. Note that numerical codes are not necessarily portable across platforms. "
      },
      {
         "string.dump(function)",
         "string",
         "=N=L=Returns a string containing a binary representation of the given function, so that a later loadstring on this string returns a copy of the function. function must be a Lua function without upvalues. "
      },
      {
         "string.find(s, pattern [, init [, plain]])",
         "(number, number)/nil",
         "=N=L=Looks for the first match of pattern in the string s. If it finds a match, then find returns the indices of s where this occurrence starts and ends; otherwise, it returns nil. A third, optional numerical argument init specifies where to start the search; its default value is 1 and may be negative. A value of true as a fourth, optional argument plain turns off the pattern matching facilities, so the function does a plain 'find substring' operation, with no characters in pattern being considered 'magic'. Note that if plain is given, then init must be given as well. If the pattern has captures, then in a successful match the captured values are also returned, after the two indices. "
      },
      {
         "string.format(formatstring, ...)",
         "string",
         "=N=L=Returns a formatted version of its variable number of arguments following the description given in its first argument (which must be a string). The format string follows the same rules as the printf family of standard C functions. The only differences are that the options/modifiers *, l, L, n, p, and h are not supported and that there is an extra option, q. The q option formats a string in a form suitable to be safely read back by the Lua interpreter: the string is written between double quotes, and all double quotes, newlines, embedded zeros, and backslashes in the string are correctly escaped when written. For instance, the call =N=L=     string.format('%q', 'a string with 'quotes' and \n new line')=N=L=will produce the string: =N=L=     'a string with \'quotes\' and \=N=L=      new line'=N=L=The options c, d, E, e, f, g, G, i, o, u, X, and x all expect a number as argument, whereas q and s expect a string. This function does not accept string values containing embedded zeros. "
      },
      {
         "string.gmatch(s, pattern)",
         "",
         "=N=L=Returns an iterator function that, each time it is called, returns the next captures from pattern over string s. If pattern specifies no captures, then the whole match is produced in each call. As an example, the following loop =N=L=     s = 'hello world from Lua'=N=L=     for w in string.gmatch(s, '%a+') do=N=L=       print(w)=N=L=     end=N=L=will iterate over all the words from string s, printing one per line. The next example collects all pairs key=value from the given string into a table: =N=L=     t = {}=N=L=     s = 'from=world, to=Lua'=N=L=     for k, v in string.gmatch(s, '(%w+)=(%w+)') do=N=L=       t[k] = v=N=L=     end"
      },
      {
         "string.gsub(s, pattern, repl [, n])",
         "string",
         "=N=L=Returns a copy of s in which all occurrences of the pattern have been replaced by a replacement string specified by repl, which may be a string, a table, or a function. gsub also returns, as its second value, the total number of substitutions made. If repl is a string, then its value is used for replacement. The character % works as an escape character: any sequence in repl of the form %n, with n between 1 and 9, stands for the value of the n-th captured substring (see below). The sequence %0 stands for the whole match. The sequence %% stands for a single %. If repl is a table, then the table is queried for every match, using the first capture as the key; if the pattern specifies no captures, then the whole match is used as the key. If repl is a function, then this function is called every time a match occurs, with all captured substrings passed as arguments, in order; if the pattern specifies no captures, then the whole match is passed as a sole argument. If the value returned by the table query or by the function call is a string or a number, then it is used as the replacement string; otherwise, if it is false or nil, then there is no replacement (that is, the original match is kept in the string). The optional last parameter n limits the maximum number of substitutions to occur. For instance, when n is 1 only the first occurrence of pattern is replaced. =N=L=Here are some examples: =N=L=     x = string.gsub('hello world', '(%w+)', '%1 %1')=N=L=     --> x='hello hello world world'=N=L=     =N=L=     x = string.gsub('hello world', '%w+', '%0 %0', 1)=N=L=     --> x='hello hello world'=N=L=     =N=L=     x = string.gsub('hello world from Lua', '(%w+)%s*(%w+)', '%2 %1')=N=L=     --> x='world hello Lua from'=N=L=     =N=L=     x = string.gsub('home = $HOME, user = $USER', '%$(%w+)', os.getenv)=N=L=     --> x='home = /home/roberto, user = roberto'=N=L=     =N=L=     x = string.gsub('4+5 = $return 4+5$', '%$(.-)%$', function (s)=N=L=           return loadstring(s)()=N=L=         end)=N=L=     --> x='4+5 = 9'=N=L=     =N=L=     local t = {name='lua', version='5.1'}=N=L=     x = string.gsub('$name%-$version.tar.gz', '%$(%w+)', t)=N=L=     --> x='lua-5.1.tar.gz'"
      },
      {
         "string.len(s)",
         "number",
         "=N=L=Receives a string and returns its length. The empty string '' has length 0. Embedded zeros are counted, so 'a\000bc\000' has length 5. "
      },
      {
         "string.lower(s)",
         "string",
         "=N=L=Receives a string and returns a copy of this string with all uppercase letters changed to lowercase. All other characters are left unchanged. The definition of what an uppercase letter is depends on the current locale. "
      },
      {
         "string.match(s, pattern [, init])",
         "string?/nil",
         "=N=L=Looks for the first match of pattern in the string s. If it finds one, then match returns the captures from the pattern; otherwise it returns nil. If pattern specifies no captures, then the whole match is returned. A third, optional numerical argument init specifies where to start the search; its default value is 1 and may be negative. "
      },
      {
         "string.rep(s, n)",
         "string",
         "=N=L=Returns a string that is the concatenation of n copies of the string s. "
      },
      {
         "string.reverse(s)",
         "string",
         "=N=L=Returns a string that is the string s reversed. "
      },
      {
         "string.sub(s, i [, j])",
         "string",
         "=N=L=Returns the substring of s that starts at i and continues until j; i and j may be negative. If j is absent, then it is assumed to be equal to -1 (which is the same as the string length). In particular, the call string.sub(s,1,j) returns a prefix of s with length j, and string.sub(s, -i) returns a suffix of s with length i. "
      },
      {
         "string.upper(s)",
         "string",
         "=N=L=Receives a string and returns a copy of this string with all lowercase letters changed to uppercase. All other characters are left unchanged. The definition of what a lowercase letter is depends on the current locale. "
      },
      {
         "select(index, ...)",
         "",
         "=N=L=If index is a number, returns all arguments after argument number index. Otherwise, index must be the string '#', and select returns the total number of extra arguments it received. "
      },
      {
         "setfenv(f, table)",
         "",
         "=N=L=Sets the environment to be used by the given function. f can be a Lua function or a number that specifies the function at that stack level: Level 1 is the function calling setfenv. setfenv returns the given function. =N=L=As a special case, when f is 0 setfenv changes the environment of the running thread. In this case, setfenv returns no values. "
      },
      {
         "setmetatable(table, metatable)",
         "",
         "=N=L=Sets the metatable for the given table. (You cannot change the metatable of other types from Lua, only from C.) If metatable is nil, removes the metatable of the given table. If the original metatable has a '__metatable' field, raises an error. =N=L=This function returns table. "
      }
   },
   {--T
      {
         "table.getn(table)",
         "Number",
         ""
      },
      {
         "table.concat(table [, sep [, i [, j]]])",
         "table",
         "=N=L=Returns table[i]..sep..table[i+1] ... sep..table[j]. The default value for sep is the empty string, the default for i is 1, and the default for j is the length of the table. If i is greater than j, returns the empty string. "
      },
      {
         "table.insert(table, [pos,] value)",
         "nil",
         "=N=L=Inserts element value at position pos in table, shifting up other elements to open space, if necessary. The default value for pos is n+1, where n is the length of the table, so that a call table.insert(t,x) inserts x at the end of table t. "
      },
      {
         "table.maxn(table)",
         "number",
         "=N=L=Returns the largest positive numerical index of the given table, or zero if the table has no positive numerical indices. (To do its job this function does a linear traversal of the whole table.) "
      },
      {
         "table.remove(table [, pos])",
         "nil",
         "=N=L=Removes from table the element at position pos, shifting down other elements to close the space, if necessary. Returns the value of the removed element. The default value for pos is n, where n is the length of the table, so that a call table.remove(t) removes the last element of table t. "
      },
      {
         "table.sort(table [, comp])",
         "",
         "=N=L=Sorts table elements in a given order, in-place, from table[1] to table[n], where n is the length of the table. If comp is given, then it must be a function that receives two table elements, and returns true when the first is less than the second (so that not comp(a[i+1],a[i]) will be true after the sort). If comp is not given, then the standard Lua operator < is used instead. The sort algorithm is not stable; that is, elements considered equal by the given order may have their relative positions changed by the sort. "
      },
      {
         "Timer.new([startTime])",
         "Timer",
         "=N=L=Creates a new Timer object, sets to 0 or startTime in milliseconds if specified, but doesn't start ticking as yet."
      },
      {
         "tonumber(e [, base])",
         "",
         "=N=L=Tries to convert its argument to a number. If the argument is already a number or a string convertible to a number, then tonumber returns this number; otherwise, it returns nil. =N=L=An optional argument specifies the base to interpret the numeral. The base may be any integer between 2 and 36, inclusive. In bases above 10, the letter 'A' (in either upper or lower case) represents 10, 'B' represents 11, and so forth, with 'Z' representing 35. In base 10 (the default), the number may have a decimal part, as well as an optional exponent part. In other bases, only unsigned integers are accepted. "
      },
      {
         "tostring(e)",
         "",
         "=N=L=Receives an argument of any type and converts it to a string in a reasonable format. For complete control of how numbers are converted, use string.format. =N=L=If the metatable of e has a '__tostring' field, then tostring calls the corresponding value with e as argument, and uses the result of the call as its result. "
      },
      {
         "type(v)",
         "",
         "=N=L=Returns the type of its only argument, coded as a string. The possible results of this function are 'nil' (a string, not the value nil), 'number', 'string', 'boolean', 'table', 'function', 'thread', and 'userdata'. "
      }
   },
   {--U
      {
         "unpack(list [, i [, j]])",
         "",
         "=N=L=Returns the elements from the given table. This function is equivalent to =N=L=     return list[i], list[i+1], ..., list[j]=N=L=except that the above code can be written only for a fixed number of elements. By default, i is 1 and j is the length of the list, as defined by the length operator. "
      }
   },
   {--V
   },
   {--W
      {
         "Wlan.init()",
         "",
         "=N=L=Must be called once at program start to initialize the WLAN module."
      },
      {
         "Wlan.term()",
         "nil",
         "=N=L=Unloads the WLAN module."
      },
      {
         "Wlan.getConnectionConfigs()",
         "Array",
         "=N=L=Gets the available WiFi connection configurations."
      },
      {
         "Wlan.useConnectionConfig(number)",
         "",
         "=N=L=Selects the connection configuration. The number is the index in the array that is returned by Wlan.getConnectionConfigs (e.g. use 1 for the first configuration)."
      },
      {
         "Wlan.getIPAddress()",
         "String",
         "=N=L=Gets the IP address of the PSP."
      }
   },
   {--X
      {
         "xpcall(f, err)",
         "",
         "=N=L=This function is similar to pcall, except that you can set a new error handler. =N=L=xpcall calls function f in protected mode, using err as the error handler. Any error inside f is not propagated; instead, xpcall catches the error, calls the err function with the original error object, and returns a status code. Its first result is the status code (a boolean), which is true if the call succeeds without errors. In this case, xpcall also returns all results from the call, after this first result. In case of any error, xpcall returns false plus the result from err. "
      }
   },
   {--Y
   },
   {--Z
   },
   {--[
   },
   {--\
   },
   {--]
   },
   {--^
   },
   {--_
      {
         "_G",
         "",
         "=N=L=A global variable (not a function) that holds the global environment (that is, _G._G = _G). Lua itself does not use this variable; changing its value does not affect any environment, nor vice-versa. (Use setfenv to change environments.) "
      },
      {
         "_VERSION",
         "",
         "=N=L=A global variable (not a function) that holds a string containing the current interpreter version. The current contents of this variable is 'Lua 5.1'. "
      }
   }
}
