dofile("CLAVIER.LUA")
dofile("io.lua")

function Chercher_version()
   local dossier= string.sub(dos, 1, -2)
   local S= System.currentDirectory(dossier)
   local f= io.open("eboot.pbp", "rb")
   f:seek("set", 1)
   local eboot= f:read(3)
   local i, j
   
   if string.lower(eboot)~="pbp" then
      System.currentDirectory("..")
      f:close()
      for j= string.len(dossier), 1, -1 do
         if string.sub(dossier, j, j)=="/" then
            i= j
            break
         end
      end
      local appl= string.sub(dossier, i+1).."%"
      System.currentDirectory(appl)
      f= io.open("eboot.pbp", "rb")
      eboot= f:read(4)
   end

   i= 5
   while string.lower(eboot)~="png" do
      f:seek("set", i)
      eboot= f:read(3)
      i= i+1
      if i>1024 then
         f:close()
         return "(version unknown)"
      end
   end
   j= 0
   i= i-4
   repeat
      j= j+1
      f:seek("set", i-j)
      if j>130 then
         return "(version unknown)"
      end
   until string.byte(f:read(1))~=0
   i= i-j
   j= 0
   repeat
      j= j+1
      f:seek("set", i-j)
      if j>130 then
         return "(version unknown)"
      end
   until string.byte(f:read(1))==0
   
   eboot= f:read(126)
   eboot= string.match(eboot, "%Z*")
   f:close()
   System.currentDirectory(S)
   return eboot
end


function Detect_com()
   local bascule= 1
   local a
   option.comm= {}
   for i= 1, table.getn(save) do
      if bascule==1 then
         a= string.find(save[i], "%-%-%[%[")
         if a~=nil then
            option.comm[table.getn(option.comm)+1]= {i, i}
            bascule= 1-bascule
         end
      end
      if bascule==0 then
         a= string.find(save[i], "%]%]")
         if a~=nil then
            option.comm[table.getn(option.comm)][2]= i
            bascule= 1-bascule
         end
      end
   end
end


function Afficher_texteC(debut)
   local str, a, b, d
   Afficher_texte(debut)
   local comm= false
   for i= 1, table.getn(option.comm) do
      if cadre.y>=option.comm[i][1] and cadre.y<=option.comm[i][2] then
         comm= true
         break
      end
   end
   for i= debut, debut+22 do
      a= 1
      b= 1
      d= 1
      str= lignes[i-debut+1]
      if str~=nil then
         if comm then
            screen:print(option.decalage*8+1, (i-debut)*10+29, str, couleur.vert)
            if string.find(save[i], "%]%]")~=nil then
               comm= false
            end
         else
            if string.find(save[i], "%-%-%[%[")~=nil then
               comm= true
               screen:print(option.decalage*8+1, (i-debut)*10+29, str, couleur.vert)
               if string.find(save[i], "%]%]")~=nil then
                  if string.find(save[i], "%]%]")>string.find(save[i], "%-%-%[%[") then
                     comm= false
                  end
               end
            else
               --expression de lua
               string.gsub(str, "%a+", function(w) 
                  local c
                  c= string.len(w)
                  if c>8 then
                     return
                  end
                  for j= 1, table.getn(syntax[c]) do
                     if syntax[c][j]==w then
                        d= string.find(str, w, d)
                        screen:print((d-1+option.decalage)*8+1, (i-debut)*10+29, w, couleur.noir)
                        return
                     end
                  end
               end)
               --nombre
               if string.find(str, "%d%w*")==1 then
                  screen:print((option.decalage)*8+1, (i-debut)*10+29, string.match(str, "%d%w*"), couleur.bleu)
               end
               string.gsub(str, "(%W%d%w*)", function(w) b= string.find(str, w, b, true)+1 screen:print((b-1+option.decalage)*8+1, (i-debut)*10+29, string.sub(w, 2), couleur.bleu) end)
               
               --ponctuation
               string.gsub(str, "(%p+)", function(w) a= string.find(str, w, a, true)+1 screen:print((a-1+option.decalage)*8-7, (i-debut)*10+29, w, couleur.noir) end)
               
               Commentaire_texte(save[i], (i-debut)*10+29)
            end
         end
      end
   end 
end


function Msg()
   if statut.etat=="Selection" then
      statut.msg= "Selecting..."
   end
   if statut.etat=="rien" then
      statut.msg= System.currentDirectory().."/"..name
      statut.var= 0
   end
   if statut.etat=="Goto" then
      statut.msg= "Goto line "
   end
   if statut.etat=="Chercher" then
      if statut.val[1]~=nil then
         statut.msg= "Search for \""..statut.val[1].."\""
         statut.val[8]= statut.val[1]
      else
         statut.var= 2
         statut.msg= "Search for \"\""
      end
   end
end


function Evenement_()
   local texte
   local touche
   do
      local tableau= {}
      KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
      if statut.etat=="rien" then
         if statut.var==4 then
            if Sauter() then
               Msg()
            end
         end
         if tableau[math.ceil(Log2(touches[3][2]))] and tableau[math.ceil(Log2(touches[3][3]))] and not option.clavier then
            while tableau[math.ceil(Log2(touches[3][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            statut.msg= "/\\:Top  \\/:Bottom  <:PgUp  >:PgDown  []:Home  O:End"
            statut.var= 4
         end
      end
      if option.clavier then
         texte= Clavier(323, 100)
         if statut.etat== "rien" then
            if texte~=nil then
               if cadre.x+curseur.x>50 then
                  if cadre.x+curseur.x<67 then
                     Ajouter_char(texte)
                  end
               else
                  Ajouter_hex(string.upper(texte))
               end
               VerifierX()
            end
         elseif statut.etat=="Goto" then
            if texte~=nil then
               statut.val[1]= statut.val[1]..texte
            end
            option.clavier= true
            Goto()
         elseif statut.etat=="Chercher" then
            if texte~=nil then
               statut.var= 2
               statut.val[1]= statut.val[1]..texte
            end
            option.clavier= true
            Chercher()
         end
      else
         --Aller a
         if tableau[math.ceil(Log2(touches[4][2]))] and tableau[math.ceil(Log2(touches[4][3]))] then
            while tableau[math.ceil(Log2(touches[4][2]))] or tableau[math.ceil(Log2(touches[4][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            statut.etat= "Goto"
            statut.val[1]= "0"
            statut.val[2]= option.type
            statut.val[3]= option.type2
            option.clavier= true
         end
      end
   end
   if pad:select() and not oldpad:select() and statut.etat=="rien" then
      if not option.clavier then
         Raccourcis()
      end
   end
   if pad:l() and pad:r() and not option.clavier then
      if Menu() then
         return true
      end
   end
   if pad:start() and not oldpad:start() and statut.etat=="rien" then
      if option.clavier then
         option.clavier= false
      else
         if option.autocomp then
            statut.val[7]= {1, 0}
         end
         option.clavier= true
      end
   end
   if statut.etat=="rien" or statut.etat=="Selection" then
      Curseur()
   end
   if (curseur.x+cadre.x+1)/3==math.ceil((curseur.x+cadre.x+1)/3) and curseur.x+cadre.x<=45 then
      if not pad:left() and pad:analogX()>-50 then
         curseur.x= curseur.x+1
      else
         curseur.x= curseur.x-1
      end
      VerifierX()
   end
end


function Evenement()
   local texte
   local touche
   
   do
      local tableau= {}
      KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
      if statut.etat=="Selection" or statut.etat=="rien" then
         if statut.var==4 then
            if Sauter() then
               if statut.etat=="Selection" then
                  statut.msg= "Selecting..."
                  statut.var= 1
               else
                  Msg()
               end
            end
         end
         if tableau[math.ceil(Log2(touches[3][2]))] and tableau[math.ceil(Log2(touches[3][3]))] then
            while tableau[math.ceil(Log2(touches[3][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            if statut.var==4 then
               if statut.etat=="Selection" then
                  statut.msg= "Selecting..."
                  statut.var= 1
               else
                  Msg()
               end
            elseif not option.clavier then
               statut.msg= "/\\:Top  \\/:Bottom  <:PgUp  >:PgDown  []:Home  O:End"
               statut.var= 4
            end
         end
      end
      if option.clavier then
         texte= Clavier(323, 100)
         if option.autocomp and texte~=nil then
            statut.val[7]= {1, 0}
         end
         if statut.etat== "rien" then
            if texte~=nil then
               save[curseur.y+cadre.y]= Inserer_texte(texte, save[curseur.y+cadre.y])
               if option.coloration and (texte=="[" or texte=="]")then
                  Detect_com()
               end
               VerifierX()
            end
         elseif statut.etat=="Goto" then
            if texte~=nil then
               statut.val[1]= statut.val[1]..texte
            end
            option.clavier= true
            Goto()
         elseif statut.etat=="Chercher" then
            if texte~=nil then
               statut.var= 2
               statut.val[1]= statut.val[1]..texte
            end
            option.clavier= true
            Chercher()
         end
      else
         if tableau[math.ceil(Log2(touches[6][2]))] and tableau[math.ceil(Log2(touches[6][3]))] then
            while tableau[math.ceil(Log2(touches[6][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            Indenter(2)
         end
         if tableau[math.ceil(Log2(touches[7][2]))] and tableau[math.ceil(Log2(touches[7][3]))] then
            while tableau[math.ceil(Log2(touches[7][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            Indenter(1)
         end
         --Tester
         if tableau[math.ceil(Log2(touches[8][2]))] and tableau[math.ceil(Log2(touches[8][3]))] then
            while tableau[math.ceil(Log2(touches[8][2]))] or tableau[math.ceil(Log2(touches[8][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            Tester()
         end
         --Aller a
         if tableau[math.ceil(Log2(touches[4][2]))] and tableau[math.ceil(Log2(touches[4][3]))] then
            while tableau[math.ceil(Log2(touches[4][2]))] or tableau[math.ceil(Log2(touches[4][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            statut.val[5]= statut.etat
            statut.etat= "Goto"
            statut.val[1]= "0"
            statut.val[2]= option.type
            statut.val[3]= option.type2
            option.clavier= true
         end
         --Chercher
         if tableau[math.ceil(Log2(touches[5][2]))] and tableau[math.ceil(Log2(touches[5][3]))] then
            while tableau[math.ceil(Log2(touches[5][2]))] or tableau[math.ceil(Log2(touches[5][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            statut.etat= "Chercher"
            statut.val[1]= statut.val[8]
            if statut.val[1]==nil then
               statut.val[1]= ""
            end
            statut.val[2]= " without breaks"
            statut.val[3]= curseur.x+cadre.x
            statut.val[4]= curseur.y+cadre.y
            option.clavier= true
         end
         --Selectionner
         if tableau[math.ceil(Log2(touches[1][2]))] and tableau[math.ceil(Log2(touches[1][3]))] then
            while tableau[math.ceil(Log2(touches[1][2]))] or tableau[math.ceil(Log2(touches[1][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            if statut.etat=="rien" then
               statut.etat= "Selection"
               statut.msg= "Selecting..."
            elseif statut.etat=="Selection" then
               if curseur.y+cadre.y~=statut.val[3]+statut.val[4] or curseur.x+cadre.x~=statut.val[1]+statut.val[2] then
                  Sauver()
               end
               statut.etat= "rien"
               Msg()
            end
         end
         if tableau[math.ceil(Log2(touches[2][2]))] and tableau[math.ceil(Log2(touches[2][3]))] then
            while tableau[math.ceil(Log2(touches[2][2]))] or tableau[math.ceil(Log2(touches[2][3]))] do
               KB_Read_Mask(Controls.read():buttons(), 32768, tableau)
            end
            pad= Controls.read()
            if statut.etat~="Selection" then
               Coller()
               if option.coloration then
                  Detect_com()
               end
            end
         end
         if pad:cross() and not oldpad:cross() then
            Inserer_ligne()
         end
         if pad:triangle() and not oldpad:triangle() then
            if statut.etat=="Selection" then
               Supprimer_sel()
               if option.coloration then
                  Detect_com()
               end
               Msg()
            else
               Effacer()
            end
         end
      end
   end
   if pad:select() and not oldpad:select() and statut.etat=="rien" then
      if not option.clavier then
         Raccourcis()
      elseif option.autocomp then
         if table.getn(statut.val[6])>0 then
            Inserer_AC()
         end
      
      end
   end
   if pad:l() and pad:r() and not option.clavier then
      if Menu() then
         return true
      end
   end
   if pad:start() and not oldpad:start() and statut.etat=="rien" then
      if option.clavier then
         option.clavier= false
      else
         if option.autocomp then
            statut.val[7]= {1, 0}
         end
         option.clavier= true
      end
   end
   if statut.etat=="rien" or statut.etat=="Selection" then
      Curseur()
   end
end


function Test_modif(a, b)
   if table.getn(modif)==0 then
      modif[1]= {a, b}
   end
   for i= 1, table.getn(modif) do
      if modif[i][1]==a then
         modif[i]= {a, b}
         break
      end
      if modif[i][1]>a then
         table.insert(modif, i, {a, b})
         break
      end
      if modif[i][1]<a and i==table.getn(modif) then
         table.insert(modif, i+1, {a, b})
         break
      end
   end
end


function Affich_modif()
   local ligne, colonne, car
   for i= 1, table.getn(modif) do
      ligne= math.floor(modif[i][1]/16)+1
      colonne= (modif[i][1]/16-math.floor(modif[i][1]/16))*16
      if ligne>=cadre.y and ligne<cadre.y+22 then
         car= string.format("%c", modif[i][2])
         if car==nil then
            car= "."
         end
         save[ligne-cadre.y+1]= string.sub(save[ligne-cadre.y+1], 1, colonne*3)..string.format("%02X", modif[i][2])..string.sub(save[ligne-cadre.y+1], colonne*3+3)
         save[ligne-cadre.y+1]= string.sub(save[ligne-cadre.y+1], 1, 51+colonne)..car..string.sub(save[ligne-cadre.y+1], 53+colonne)
      end
   end
end


function Ajouter_char(char)
   local x= cadre.x+curseur.x
   local x2= (x-51)*3
   save[curseur.y+1]= string.sub(save[curseur.y+1], 1, x)..char..string.sub(save[curseur.y+1], x+2)
   save[curseur.y+1]= string.sub(save[curseur.y+1], 1, x2)..string.format("%02X", string.byte(char))..string.sub(save[curseur.y+1], x2+3)
   curseur.x= curseur.x+1
   Test_modif((cadre.y+curseur.y-1)*16+x-51, string.byte(char))
end


function Ajouter_hex(char)
   local x= math.ceil((cadre.x+curseur.x-2)/3)
   if ((char<"0" or char>"9") and (char<"A" or char>"F")) or cadre.x+curseur.x>46 then
      return
   end
   save[curseur.y+1]= string.sub(save[curseur.y+1], 1, cadre.x+curseur.x)..char..string.sub(save[curseur.y+1], cadre.x+curseur.x+2)
   local car= string.format("%c", tonumber("0x"..Recup()))
   if car==nil then
      car= "."
   end
   save[curseur.y+1]= string.sub(save[curseur.y+1], 1, 51+x)..car..string.sub(save[curseur.y+1], 53+x)
   Test_modif((cadre.y+curseur.y-1)*16+x, tonumber("0x"..Recup()))
   curseur.x= curseur.x+1
end


function Recup()
   local a= curseur.x+cadre.x+1
   repeat
      if a==0 then
         break
      end
      a= a-1
   until string.sub(save[curseur.y+1], a, a)==" "
   return string.match(save[curseur.y+1], "%w+", a+1)
end


function Recup_hex(val)
   local byte, str
   if val=="fin" then
      return
   end
   if val<0 then
      for i= -1, val, -1 do
         cadre.y= cadre.y-1
         f_hex:seek("set", cadre.y*16-16)
         byte= f_hex:read(16)
         if not byte then
            break
         end
         str= ""
         for b in string.gfind(byte, ".") do
            str= str..string.format("%02X ", string.byte(b))
         end
         str= str..string.rep("   ", 16-string.len(byte)+1)
         str= str..string.gsub(byte, "%c", ".")
         table.insert(save, 1, str)
         if table.getn(save)>23 then
            table.remove(save, table.getn(save))
         end
      end
   end
   if val>0 then
      for i= 1, val do
         table.remove(save, 1)
         cadre.y= cadre.y+1
         if (cadre.y+22)*16<=f_hex:seek("end") then
            f_hex:seek("set", (cadre.y+21)*16)
            byte= f_hex:read(16)
            if not byte then
               break
            end
            str= ""
            for b in string.gfind(byte, ".") do
               str= str..string.format("%02X ", string.byte(b))
            end
            str= str..string.rep("   ", 16-string.len(byte)+1)
            str= str..string.gsub(byte, "%c", ".")
            save[table.getn(save)+1]= str
         end
      end
   end
   Affich_modif()
end


function Charger_bloc()
   --algorythme venant du wiki sur le lua
   save= {}
   f_hex:seek("set", (cadre.y-1)*16)
   for i= cadre.y, cadre.y+22 do
      local byte= f_hex:read(16)
      if not byte then
         break
      end
      save[i-cadre.y+1]= ""
      for b in string.gfind(byte, ".") do
         save[i-cadre.y+1]= save[i-cadre.y+1]..string.format("%02X ", string.byte(b))
      end
      save[i-cadre.y+1]= save[i-cadre.y+1]..string.rep("   ", 16-string.len(byte)+1)
      save[i-cadre.y+1]= save[i-cadre.y+1]..string.gsub(byte, "%c", ".")
   end
   Affich_modif()
end
            

function VerifierX_(mouv)
   if curseur.x<0 then
      if cadre.x>1 then
         curseur.x= 0
         cadre.x= cadre.x-1
      else
         if curseur.y>0 then
            curseur.y= curseur.y-1
            if lignes[curseur.y]=="" then
               curseur.x= 0
            else
               cadre.x= 0
               curseur.x= 67   --string.len(save[])
               if curseur.x>60-option.decalage then
                  curseur.x= 60-option.decalage
                  cadre.x= 67-(60-option.decalage)
               end
            end
            VerifierY_()
         else
            if cadre.y>1 then
               --cadre.y= cadre.y-1
               Recup_hex(-1)
               curseur.x= 67
               if curseur.x>60-option.decalage then
                  curseur.x= 60-option.decalage
                  cadre.x= 67-(60-option.decalage)
               end
            else
               curseur.x= 0
            end
         end
      end
   end
   if curseur.x+cadre.x>67 then
      if mouv==0 then
         curseur.x= 0
         curseur.y= curseur.y+1
         cadre.x= 0
         VerifierY_()
      else
         cadre.x= 0
         curseur.x= 67
         if curseur.x>60-option.decalage then
            curseur.x= 60-option.decalage
            cadre.x= 67-(60-option.decalage)
         end
      end
   end
   if curseur.x>59-option.decalage then
      curseur.x= 59-option.decalage
      cadre.x= cadre.x+1
      VerifierX_()
   end
end


function VerifierY_(mouv)
   if curseur.y<0 then
      if cadre.y>1 then
         Recup_hex(-1)
      else
         curseur.x= 0
         cadre.x= 0
      end
      curseur.y= 0
   end
   if curseur.y>22 then
      if cadre.y+22<f_hex:seek("end")/16 then
         Recup_hex(1)
      else
         cadre.y= math.ceil(f_hex:seek("end")/16)-22
      end
      curseur.y= 22
   end
   if option.clavier then
      if curseur.y>6 then
         Recup_hex(curseur.y-6)
         curseur.y= 6
      end
   end
   if curseur.y+cadre.y>=math.ceil(f_hex:seek("end")/16) then
      if option.hex then
         Recup_hex("fin")
      end
      curseur.y= 22
   end
   if curseur.y+1>table.getn(save) then
      curseur.y= table.getn(save)-1
   end
end


function Tester()
   System.currentDirectory(dossier_en_cours)
   local fichiers= System.listDirectory()
   local tmp= true
   for i= 1, table.getn(fichiers) do
      if string.lower(fichiers[i].name)==string.lower(name) then
         tmp= false
         break
      end
   end
   if tmp then
      return
   end
   dofile(name)
   Init()
   repeat
   until Controls.read():buttons()==0
end


function Test_nil(a, str)
   if a==nil then
      return string.len(str)+1
   end
   return a
end

function Commentaire_texte(str, y)
   local apos, guil, com, apos_, guil_, com_, c, a, a_, coul
   c= 1

   repeat
      apos= Test_nil(string.find(str, "%'", c), str)
      guil= Test_nil(string.find(str, '%"', c), str)
      com= Test_nil(string.find(str, "%-%-", c), str)
      com_= string.match(str, "%-%-.*", c)
      if apos==guil and guil==com then
         return
      end
      
      if guil<apos then
         a_= string.match(str, '%".-%"', c)
         if a_==nil then
            a_= string.match(str, '%".*', c)
         end
         a= guil
         coul= couleur.mauve
      else
         a_= string.match(str, "%'.-%'", c)
         if a_==nil then
            a_= string.match(str, "%'.*", c)
         end
         a= apos
         coul= couleur.mauve
      end
      if com<a then
         a= com
         a_= com_
         coul= couleur.vert
      end
      c= a+string.len(a_)
      if cadre.x-a>=-1 then
         screen:print(option.decalage*8+1, y, string.sub(a_, cadre.x-a+2), coul)
      else
         screen:print((a-cadre.x+option.decalage)*8-7, y, a_, coul)
      end
   until c>=string.len(str)
end



function Afficher_texte(debut)
   for i= debut, debut+22 do
      if lignes[i-debut+1]~=nil then
         if option.numero_lignes then
            screen:print(1+8*option.decalage, ((i - debut) + 3)*10 - 1, lignes[i-debut+1], couleur.texte)
            screen:print(4*math.floor(option.decalage-math.log10(i+1))+1, (i - debut + 3)*10 - 1, i, couleur.noir)
         elseif option.scroll then
            screen:print(1+8*option.decalage, ((i - debut) + 3)*10 - 1, lignes[i-debut+1], couleur.texte)
         else
            screen:print(1, ((i - debut) + 3)*10 - 1, lignes[i-debut+1], couleur.texte)
         end
      end
   end
end


function Dependance(tabl, j, file)
   local tmp1, tmp2, temp, fic
   local str= tabl[j]

   tmp1= string.find(str, "-")
   tmp2= string.find(str, "dofile")
   if tmp2==nil then
      tmp2= string.find(str, "require")
   end
   
   if tmp1~=nil and string.sub(str, tmp1+1, tmp1+1)=="-" then
      if tmp2>tmp1 then
         return
      end
   end
   tmp1= tmp2+6
   while string.sub(str, tmp1, tmp1)==" " do
      tmp1= tmp1+1
      if tmp1>string.len(str) then
         return
      end
   end
   if string.sub(str, tmp1, tmp1)~="(" then
      return
   end
   while string.sub(str, tmp2, tmp2)~='\"' do
      if string.sub(str, tmp2, tmp2)==")" then
         return
      end
      tmp2= tmp2+1
   end
   tmp1= tmp2+1
   while string.sub(str, tmp1, tmp1)~='\"' do
      tmp1= tmp1+1
   end
   temp= string.lower(string.sub(str, tmp2+1, tmp1-1))
   for i= 1, j-1 do
      if tabl[i]==temp then
         return
      end
   end
   tmp1= System.listDirectory()
   tmp2= false
   for i= 1, table.getn(tmp1) do
      if string.lower(tmp1[i].name)==temp then
         tmp2= true
         break
      end
   end
   if tmp2 then
      save= {}
      fic= io.open(temp)
      for line in fic:lines() do
         save[table.getn(save)+1]= line
      end
      fic:close()
      Process()
      Boucle(file)
      Process()
   end
   return temp
end


function Boucle(file)
   local tmp, tmp2, a
   local tabl= {}
   for i= 1, table.getn(save) do
      if string.find(save[i], "dofile")~=nil or string.find(save[i], "require")~=nil then
         tabl[table.getn(tabl)+1]= save[i]
      end
      tmp= string.find(save[i], "function ")
      if tmp~=nil then
         tmp= tmp+8
         while string.sub(save[i], tmp, tmp)==" " do
            tmp= tmp+1
         end
         tmp2= tmp
         a= string.upper(string.sub(save[i], tmp2, tmp2))
         --le nom de la fct commence par une lettre ou _
         if (a>="A" and a<="Z") or a=="_" then
            while (a>="A" and a<="Z") or (a>="0" and a<="9") or a=="_" or a==":" do
               --pour les fct composees
               if a==":" then
                  tmp= tmp2
               end
               tmp2= tmp2+1
               a= string.upper(string.sub(save[i], tmp2, tmp2))
               if tmp2>string.len(save[i]) then
                  break
               end
            end
            a= tmp2
            while string.sub(save[i], a, a)==" " do
               a= a+1
            end
            --si c'est une fct: il y a des parentheses
            if string.sub(save[i], a, a)~="(" then
               tmp= tmp2
            end          
            if tmp~=tmp2 then
               file:write(string.sub(save[i], tmp, tmp2-1).."()\n")
            end
         end
      end
   end
   return tabl
end


function Init_autoc()
   local file, tabl, tmp, temp, tmp2, text
   
   text= {}
   for i= 1, table.getn(save) do
      text[i]= save[i]
   end

   temp= System.currentDirectory()
   System.currentDirectory(dos.."Applications/lowser")
   AutoC= nil
   dofile("AutoCompletion.lua")
   file= io.open("autocomp.lua", "w")
   tabl= Boucle(file)
   System.currentDirectory(temp)

   if table.getn(tabl)~=nil then
      for i= 1, table.getn(tabl) do
         tabl[i]= Dependance(tabl, i, file)
      end
   end
   save= {}
   for i= 1, table.getn(text) do
      save[i]= text[i]
   end
   file:close()
end


function Ajouter_fct()
   local file, tabl, tmp, temp

   tmp= System.currentDirectory()
   System.currentDirectory(dos.."Applications/lowser")
   tabl= System.listDirectory()
   temp= false
   for i= 1, table.getn(tabl) do
      if tabl[i].name=="autocomp.lua" then
         temp= true
         break
      end
   end
   if temp then
      file= io.open("autocomp.lua")
      for line in file:lines() do
         tabl= string.byte(string.upper(string.sub(line, 1, 1)))
         if tabl==nil then
            break
         end
         if tabl>=58 or tabl<=95 then
         pad= Controls.read()
            AutoC[tabl-57][table.getn(AutoC[tabl-57])+1]= line
         end
      end
      file:close()
   end
   System.currentDirectory(tmp)   
   for i= 1, table.getn(AutoC) do
      table.sort(AutoC[i], function (a, b) return string.lower(a)<string.lower(b) end)
   end
end


function Aide_online()
   local img, str, tmp

   statut.val[6]= {}
   img= Image.createEmpty(1, 1)
   str= Prelever()
   if str==nil then
      return img
   end
   tmp= string.upper(string.sub(str, 1, 1))
   if string.byte(tmp)<58 or string.byte(tmp)>95 then
      return img
   end
   tmp= Help[string.byte(tmp)-string.byte(":")+1]
   for i= 1, table.getn(tmp) do
      if string.find(tmp[i][1], str)~=nil then
         statut.val[6][table.getn(statut.val[6])+1]= tmp[i][1]
         if tmp[i][2]~=nil and tmp[i][2]~="" then
            statut.val[6][table.getn(statut.val[6])+1]= "Data returned: "..tmp[i][2]
         else
            statut.val[6][table.getn(statut.val[6])+1]= "Data returned: Unknown"
         end
         if tmp[i][3]~=nil and tmp[i][3]~="" then
            Mise_en_forme(tmp[i][3], table.getn(statut.val[6]))
         else
            statut.val[6][table.getn(statut.val[6])+1]= "Description:"
            statut.val[6][table.getn(statut.val[6])+1]= " No information for this function."
         end
         statut.val[6][table.getn(statut.val[6])+1]= " "
      end
   end
   if table.getn(statut.val[6])<1 then
      return img
   end
   
   img= Image.createEmpty(480, 122)
   img:clear(couleur.blanc)
   img:drawLine(0, 0, 480, 0, couleur.noir)
   img:drawLine(480, 0, 480, 121, couleur.noir)
   img:drawLine(480, 121, 0, 121, couleur.noir)
   img:drawLine(0, 121, 0, 0, couleur.noir)

   for i= statut.val[7][1], statut.val[7][1]+12 do
      if i>table.getn(statut.val[6]) then
         break
      end
      img:print(4, (i-statut.val[7][1])*10+3, statut.val[6][i], couleur.noir)
      if statut.val[6][i]=="Description:" then
         img:print(4, (i-statut.val[7][1])*10+3, "Description:", couleur.gris)
         img:print(4, (i-statut.val[7][1]-1)*10+3, "Data returned:", couleur.gris)
         tmp= i-2
         while tmp-statut.val[7][1]>=0 and statut.val[6][tmp]~=" " do
            img:print(4, (tmp-statut.val[7][1])*10+3, statut.val[6][tmp], couleur.rouge)
            tmp= tmp-1
         end
      end
   end
   return img
end


function Recup_parametres()
   local file, rep, tmp
   rep= System.currentDirectory()
   System.currentDirectory(dos.."Applications/lowser")
   file= io.open("param.lua")
   touches= {}
   for i= 1, 8 do
      touches[i]= {}
      for j= 1, 3 do
         if j==1 then
            touches[i][j]= file:read()
         else
            touches[i][j]= file:read("*n", "*l")
         end
      end
   end
   
   option.autocomp= T_F(file:read())
   option.aide= T_F(file:read())
   if option.autocomp and option.aide then
      option.autocomp= false
   end
   option.numero_lignes= T_F(file:read())
   option.coloration= T_F(file:read())
   option.scroll= T_F(file:read())
   option.bg= file:read()
   
   tmp= {}
   for i= 1, 6 do
      tmp[i]= file:read("*n", "*l")
   end
   file:close()
   couleur.perso= Color.new(tmp[1], tmp[2], tmp[3])
   couleur.texte= Color.new(tmp[4], tmp[5], tmp[6])
   System.currentDirectory(rep)
end


function T_F(a)
   if a=="false" then
      return false
   end
   if a=="true" then
      return true
   end
end


function Sauv_parametres()
   local file, rep
   rep= System.currentDirectory()
   System.currentDirectory(dos.."Applications/lowser")
   file= io.open("param.lua", "w")
   for i= 1, table.getn(touches) do
      for j= 1, 3 do
         file:write(touches[i][j].."\n")
      end
   end
   file:write(V_F(option.autocomp))
   file:write(V_F(option.aide))
   file:write(V_F(option.numero_lignes))
   file:write(V_F(option.coloration))
   file:write(V_F(option.scroll))
   file:write(option.bg.."\n")
   file:write(couleur.perso:colors().r.."\n")
   file:write(couleur.perso:colors().g.."\n")
   file:write(couleur.perso:colors().b.."\n")
   file:write(couleur.texte:colors().r.."\n")
   file:write(couleur.texte:colors().g.."\n")
   file:write(couleur.texte:colors().b.."\n")
   file:close()
   System.currentDirectory(rep)
end

function V_F(a)
   if a then
      return "true\n"
   end
   if not a then
      return "false\n"
   end
end


function Tester_longueur()
   local str, chaine, char
   chaine= 1
   repeat 
      while string.len(statut.val[6][chaine])>60 do
         for i= 60, 1, -1 do
            char= string.upper(string.sub(statut.val[6][chaine], i, i))
            if (char<"A" or char>"Z") and char~="'" then
               table.insert(statut.val[6], chaine+1, " "..string.sub(statut.val[6][chaine], i+1))
               statut.val[6][chaine]= string.sub(statut.val[6][chaine], 1, i)
               break
            elseif i==1 then
               table.insert(statut.val[6], chaine+1, " "..string.sub(statut.val[6][chaine], 40))
               statut.val[6][chaine]= string.sub(statut.val[6][chaine], 1, 39).."-"
            end
         end
      end
   chaine= chaine+1
   until chaine>table.getn(statut.val[6])
end


function Mise_en_forme(str)
   local tmp
   statut.val[6][table.getn(statut.val[6])+1]= "Description:"
   str= " "..string.sub(str, 6)
   while string.find(str, "=N=L=")~=nil do
      statut.val[6][table.getn(statut.val[6])+1]= string.sub(str, 1, string.find(str, "=N=L=")-1)
      str=  " "..string.sub(str, string.find(str, "=N=L=")+5)
   end
   statut.val[6][table.getn(statut.val[6])+1]= str
   Tester_longueur()
end


function Scroll()
   local temp
   if option.hex then
      temp= 23/(math.ceil(f_hex:seek("end")/16))*230
      if temp<6 then
         temp= 6
      end
      temp= (cadre.y+curseur.y)*(230-temp)/(math.ceil(f_hex:seek("end")/16))
      if temp<0 then
         temp= 0
      end
   else
      temp= 23/table.getn(save)*230
      if temp<6 then
         temp= 6
      end
      temp= (cadre.y+curseur.y)*(230-temp)/table.getn(save)
      if temp<0 then
         temp= 0
      end
   end
   screen:blit(0, 27, image.barre)
   screen:blit(0, 27+temp, image.curs)
end


function Creer_curseur()
   local temp, transparent= 23/table.getn(save)*230
   if option.hex then
      temp= 23/(math.ceil(f_hex:seek("end")/16))*230
   end
   if temp<6 then
      temp= 6
   end
   if temp>230 then
      temp= 230
   end
   image.curs= Image.createEmpty(8, temp)
   transparent= image.curs:pixel(0, 0)
   image.curs:clear(couleur.perso)
   image.curs:pixel(0, 0, transparent)
   image.curs:pixel(7, 0, transparent)
   image.curs:pixel(0, image.curs:height()-1, transparent)
   image.curs:pixel(7, image.curs:height()-1, transparent)
   image.curs:blit(0, 0, image.curs_h)
   for i= 1, temp-6 do
      image.curs:blit(0, i+2, image.curs_m)
   end
   image.curs:blit(0, image.curs:height()-4, image.curs_b)
end


function Choisir_couleur()
   local coul, text, r, g, b, y, back, texte, bg= couleur.perso, couleur.texte, 125, 125, 125, 1, option.bg, false, option.bg
   local BG= {}
   local temp= System.currentDirectory(dos.."Applications/lowser/img/bg")

   back= System.listDirectory()
   for i= 1, table.getn(back) do
      BG[i]= string.gsub(string.lower(back[i].name), ".png", "")
   end
   table.sort(BG, function (a, b) return a<b end)
   table.remove(BG, 1)
   table.remove(BG, 1)
   back= 0
   for i= 1, table.getn(BG) do
      if option.bg==BG[i] then
         back= i
      end
   end
   System.currentDirectory(temp)
   
   r= coul:colors().r
   g= coul:colors().g
   b= coul:colors().b
   while pad:cross() do
      pad= Controls.read()
   end
   repeat
      Afficher()
      screen:fillRect(300, 28, 180, 230, couleur.blanc)
      screen:print(320, 50, "Red: "..r, couleur.noir)
      screen:print(320, 65, "Green: "..g, couleur.noir)
      screen:print(320, 80, "Blue: "..b, couleur.noir)
      screen:print(320, 220, "L: Quit", couleur.noir)
      screen:print(320, 230, "X: Select", couleur.noir)
      screen:print(320, 240, "Select: Preview", couleur.noir)
      Rect(378, 168, 401, 191)
      screen:fillRect(380, 170, 20, 20, Color.new(r, g, b))
      if back==0 then
         screen:print(320, 110, "No background", couleur.noir)
         option.bg= "aucun"
      else
         option.bg= BG[back]
         screen:print(320, 110, option.bg, couleur.noir)
      end
      if texte then
         screen:print(320, 130, "Text color", couleur.noir)
      else
         screen:print(320, 130, "Background color", couleur.noir)
      end
      if pad:down() then
         while pad:down() do
            pad= Controls.read()
         end
         y= y+1
      end
      if pad:up() then
         while pad:up() do
            pad= Controls.read()
         end
         y= y-1
      end
      if y>5 then
         y= 1
      end
      if y<1 then
         y= 5
      end
      if texte then
         couleur.texte= Color.new(r, g, b)
      else
         couleur.perso= Color.new(r, g, b)
      end
      if pad:select() then
         Creer_img()
      end
      if y==1 then
         Rect(317, 47, 386, 60)
         r= RGB(r)
      elseif y==2 then   
         Rect(317, 62, 402, 75)
         g= RGB(g)
      elseif y==3 then   
         Rect(317, 77, 394, 90)
         b= RGB(b)
      elseif y==4 then   
         Rect(317, 107, 453, 120)
         if pad:right() then
            while pad:right() do
               pad= Controls.read()
            end
            back= back+1
            if back>table.getn(BG) then
               back= 0
            end
         end
         if pad:left() then
            while pad:left() do
               pad= Controls.read()
            end
            back= back-1
            if back<0 then
               back= table.getn(BG)
            end
         end
      elseif y==5 then
         Rect(317, 127, 453, 140)
         if pad:left() or pad:right() then
            while pad:left() or pad:right() do
               pad= Controls.read()
            end
            if texte then
               texte= false
               r= couleur.perso:colors().r
               g= couleur.perso:colors().g
               b= couleur.perso:colors().b
            else
               texte= true
               r= couleur.texte:colors().r
               g= couleur.texte:colors().g
               b= couleur.texte:colors().b
            end
         end
      end
      screen.waitVblankStart()
      screen.flip()
      pad= Controls.read()
   until pad:cross() or pad:l() or pad:r()
   if pad:l() then
      couleur.perso= coul
      couleur.texte= text
      option.bg= bg
   end
   Creer_img()
   Creer_curseur()
   while pad:cross() do
      pad= Controls.read()
   end
end


function Confirmer(str, msg1, msg2, opt1, opt2)
   local y, img= 2, Image.createEmpty(141, 20*5)
   local transparent= img:pixel(0, 0)

   img:clear(couleur.perso)
   img:fillRect(0, 0, 4, 2, transparent)
   img:fillRect(0, 0, 2, 4, transparent)
   img:fillRect(0, 0, 3, 3, transparent)
   img:fillRect(137, 0, 4, 2, transparent)
   img:fillRect(139, 0, 2, 4, transparent)
   img:fillRect(138, 0, 3, 3, transparent)
   img:fillRect(0, 20*5-2, 2, 2, transparent)
   img:fillRect(139, 20*5-2, 3, 3, transparent)
   img:blit(0, 0, image.menu_h)
   for i= 1, 5-2 do
      img:blit(0, 20*i, image.menu_m)
   end
   img:blit(0, 20*5-20, image.menu_b)
   img:fontPrint(police, math.ceil((141-string.len(str)*8)/2), 16, str, couleur.rouge)
   img:fontPrint(police, 5, 40, msg1, couleur.texte)
   img:fontPrint(police, 5, 55, msg2, couleur.texte)
   
   repeat
      if statut.etat=="Ouvrir" then
         Aff_ouvrir()
      elseif statut.etat=="Enregistrer" then
         Aff_enregistrer()
      else
         Afficher()
      end
      img:fontPrint(police, 5, 75, opt1, couleur.texte)
      img:fontPrint(police, 5, 90, opt2, couleur.texte)
      if y==1 then
         img:fontPrint(police, 5, 75, opt1, couleur.rouge)
      else
         img:fontPrint(police, 5, 90, opt2, couleur.rouge)
      end
      screen:blit((480-img:width())/2, (272-img:height())/2, img)
      screen.waitVblankStart()
      screen.flip()
      while not pad:up() and not pad:down() and not pad:cross() and not pad:l() do
         pad= Controls.read()
      end
      if pad:l() then
         return "annuler"
      end
      if pad:up() or pad:down() then
         if y==1 then
            y= 2
         else
            y= 1
         end
      end
      while pad:up() or pad:down() do
         pad= Controls.read()
      end
   until pad:cross()
   while pad:cross() do
      pad= Controls.read()
   end
   if y==1 then
      return true
   else
      return false
   end
end


function RGB(r)
   if pad:left() then
      r= r-1
   end
   if pad:right() then
      r= r+1
   end
   if r<0 then
      r= 255
   end
   if r>255 then
      r= 0
   end
   return r
end


function Rect(x1, y1, x2, y2)
   screen:drawLine(x1, y1, x2, y1, couleur.noir)
   screen:drawLine(x2, y1, x2, y2, couleur.noir)
   screen:drawLine(x2, y2, x1, y2, couleur.noir)
   screen:drawLine(x1, y2, x1, y1, couleur.noir)
end


function Credit()
   local back= Image.createEmpty(480, 272)
   local dire= System.currentDirectory(dos.."Applications/lowser")

   back:clear(couleur.perso)
   back:blit(0, 0, Image.load("img/bg1.png"))
   back:blit(0, 27, Image.load("img/bg/bg2.png"))

   screen:clear()
   screen:blit(0, 0, back)
   screen:fontPrint(police, 200, 18, "CREDITS:", couleur.rouge)
   screen:fontPrint(police, 3, 75, "LuaStation is developed by Samy (alias Gogy).", couleur.texte)
   screen:fontPrint(police, 3, 105, "The English translation and testing have been completed by IMIX.", couleur.texte)
   screen:fontPrint(police, 3, 185, "A special thanks to Novservant and Sabbator, ", couleur.texte)
   screen:fontPrint(police, 3, 200, "for the first two editions of Luaprog.", couleur.texte)
   screen:fontPrint(police, 3, 215, "THANKS to sites: Xtreamlua, Pspgen, Playeradvance and Luaplayer", couleur.texte)
   screen:fontPrint(police, 3, 230, "(with Romero126) for their help.", couleur.texte)
   screen:fontPrint(police, 3, 269, "For comments: reivax_vet@hotmail.com", couleur.noir)
   screen:waitVblankStart()
   screen:flip()
   while not pad:select() and not pad:l() and not pad:r() do
      pad= Controls.read()
   end
   while pad:l() or pad:r() or pad:select() do
      pad= Controls.read()
   end
   System.currentDirectory(dire)
end


function Afficher_aide()
   local str= {}, img, x1, file, dossier, back

   dossier= System.currentDirectory()
   System.currentDirectory(dos.."Applications/lowser")
   back= Image.createEmpty(480, 272)
   back:clear(couleur.perso)
   back:blit(0, 0, Image.load("img/bg1.png"))
   back:blit(0, 27, Image.load("img/bg/bg2.png"))
   file= io.open("Help.lua")
   x1= 1
   for line in file:lines() do
      str[x1]= line
      x1= x1+1
   end
   file:close()
   x1= 1
   repeat
      screen:clear()
      screen:blit(0, 0, back)
      for i= x1, x1+21 do
         if str[i]~= nil then
            screen:fontPrint(police, 2, 12*(i-x1)+18, str[i], couleur.texte)
         end
      end
      screen:print(448, 9, (1+(x1-1)/23).."/5", couleur.texte)
      screen:waitVblankStart()
      screen:flip()
      while not pad:l() and not pad:r() and not pad:left() and not pad:right() do
         pad= Controls.read()
      end
      if pad:right() then
         x1= x1+23
      end
      if pad:left() then
         x1= x1-23
      end
      if x1<1 then
         x1= 93
      end
      if x1>93 then
         x1= 1
      end
      while pad:left() or pad:right() do
         pad= Controls.read()
      end
   until pad:l() or pad:r()
   while pad:l() or pad:r() do
      pad= Controls.read()
   end
   System.currentDirectory(dossier)
end


function Inserer_AC()
   local str1, str2, tmp1, tmp2, tmp

   str1, tmp1, tmp2= Prelever()
   if str1==nil then
      return
   end
   tmp= statut.val[6][statut.val[7][2]+statut.val[7][1]]
   str1= string.sub(save[curseur.y+cadre.y], 1, tmp1-1)
   str2= string.sub(save[curseur.y+cadre.y], tmp2+1)
   save[curseur.y+cadre.y]= str1..tmp..str2
   curseur.x= tmp1+string.len(tmp)-1
   screen:print(3, 260, string.sub(tmp, string.len(tmp)))
   if string.sub(tmp, string.len(tmp))==")" then
      curseur.x= curseur.x-1
   end
   statut.val[7]= {1, 0}
   VerifierX()
end


function AutoCompletion()
   local img, str, tmp, temp, taille
  
   img= Image.createEmpty(1, 1)
   str= Prelever()
   if str==nil then
      return img
   end
   tmp= string.sub(str, 1, 1)
   if string.byte(string.upper(tmp))<58 or string.byte(string.upper(tmp))>95 then
      return img
   end
   tmp= AutoC[string.byte(string.upper(tmp))-57]
   statut.val[6]= {}
   temp= 1
   taille= 0
   for i= 1, table.getn(tmp) do
      if str==string.sub(tmp[i], 1, string.len(str)) then
         statut.val[6][temp]= tmp[i]
         temp= temp+1
         if string.len(tmp[i])>taille then
            taille= string.len(tmp[i])
         end
      end
   end
   temp= table.getn(statut.val[6])
   if temp<1 then
      return img
   end
   if temp>7 then
      img= Image.createEmpty(taille*8+8, 73)
   else
      img= Image.createEmpty(taille*8+8, 10*temp+3)
   end
   img:clear(couleur.blanc)
   img:drawLine(0, 0, taille*8+8, 0, couleur.noir)
   img:drawLine(taille*8+8, 0, taille*8+8, 10*temp+2, couleur.noir)
   img:drawLine(taille*8+8, 10*temp+2, 0, 10*temp+2, couleur.noir)
   img:drawLine(0, 10*temp+2, 0, 0, couleur.noir)
   img:fillRect(1, 2+statut.val[7][2]*10, taille*8+6, 9, couleur.noir)
   for i= statut.val[7][1], statut.val[7][1]+7 do
      if i>table.getn(statut.val[6]) then
         break
      end
      img:print(4, (i-statut.val[7][1])*10+3, statut.val[6][i], couleur.gris)
   end
   img:print(4, 3+statut.val[7][2]*10, statut.val[6][statut.val[7][2]+statut.val[7][1]], couleur.blanc)
   return img
end


function Prelever()
   local tmp1, tmp2, sav= 0, 0
   
   if save[curseur.y+cadre.y]==nil then
      return
   end
   for i= curseur.x+cadre.x, 1, -1 do
      sav= string.byte(string.lower(string.sub(save[curseur.y+cadre.y], i, i)))
      if sav==nil then
         return
      end
      if (sav<97 or sav>122) and (sav<48 or sav>57) and sav~=95 and sav~=46 and sav~=58 then
           --a         z              0         9            :            .           _
         break
      end
      tmp1= i
      if sav==string.byte(":") then
         break
      end
   end
   if tmp1==0 then
      return
   end
   for i= curseur.x+cadre.x, string.len(save[curseur.y+cadre.y]) do
      sav= string.byte(string.lower(string.sub(save[curseur.y+cadre.y], i, i)))
      if sav==nil then
         return
      end
      if (sav<97 or sav>122) and (sav<48 or sav>57) and sav~=95 and sav~=46 and sav~=58 then
         break
      end
      tmp2= i
      if sav==string.byte(":") and i>curseur.x+cadre.x then
         break
      end
   end
   if tmp2==0 or (string.sub(save[curseur.y+cadre.y], tmp2+1, tmp2+1)=="(" and option.autocomp) then
      return
   end
   sav= string.sub(save[curseur.y+cadre.y], tmp1, tmp2)
   if table.getn(statut.val[6])==1 and sav==statut.val[6][1] then
      return
   end
   return sav, tmp1, tmp2
end


function Menu()
   local col, ligne= 1, 1
   while pad:l() or pad:r() do
      pad= Controls.read()
   end
   
   while true do
      Afficher()
      if pad:right() and not oldpad:right() then
         col= col+1
      end
      if pad:left() and not oldpad:left() then
         col= col-1
      end
      if col<1 then
         col= 3
      end
      if col>3 then
         col= 1
      end
      if pad:down() and not oldpad:down() then
         ligne= ligne+1
      end
      if pad:up() and not oldpad:up() then
         ligne= ligne-1
      end
      if ligne<1 then
         ligne= table.getn(menu[col])
      end
      if ligne>table.getn(menu[col]) then
         ligne= 1
      end
      if pad:l() then
         return
      end
      if pad:cross() and not oldpad:cross() then
         while pad:cross() do
            pad= Controls.read()
         end
         if col==1 then
            do
               local reponse
               if ligne==1 then
                  reponse= Confirmer("New", "Save document,", "continue?", "Save", "Do not save")
                  if reponse=="annuler" then
                     return false
                  end
                  if reponse then
                     dossier_en_cours= System.currentDirectory()
                     statut.etat= "Enregistrer"
                     Enregistrer()
                     statut.etat= "rien"
                  end
                  option.comm= {}
                  option.hex= false
                  save= {}
                  local d= os.date("*t", os.time())
                  local f= io.open("flash1:/registry/system.dreg", "r")
                  f:seek("set", 9088)
                  local nom= f:read(255)
                  nom= string.match(nom, "%w*")
                  if string.len(nom)<1 then
                     f:seek("set", 10624)
                     nom= f:read(255)
                     nom= string.match(nom, "%w*")
                  end
                  if string.len(nom)<1 then
                     f:seek("set", 9600)
                     nom= f:read(255)
                     nom= string.match(nom, "%w*")
                  end
                  f:close()
                  save[1]= "--Program created by "..nom..", on "..string.format("%02d", d.day).."/"..string.format("%02d", d.month).."/"..d.year..", at "..string.format("%02d", d.hour)..":"..string.format("%02d", d.min)..":"..string.format("%02d", d.sec)..","
                  save[2]= "--using "..Chercher_version().."and LuaStation."
                  save[3]= ""
                  Creer_curseur()
               elseif ligne==2 then
                  reponse= Confirmer("Open", "Save document,", "continue?", "Save", "Do not save")
                  if reponse=="annuler" then
                     return false
                  end
                  if reponse then
                     statut.etat= "Enregistrer"
                     Enregistrer()
                     statut.etat= "rien"
                  end
                  statut.etat= "Ouvrir"
                  if Ouvrir() then
                     Creer_curseur()
                     curseur.x= 0
                     cadre.x= 0
                     curseur.y= 0
                     cadre.y= 1
                     if option.coloration then
                        Detect_com()
                     end
                  end
                  statut.etat= "rien"
               elseif ligne==3 then
                  statut.etat= "Enregistrer"
                  Enregistrer()
                  statut.etat= "rien"
               elseif ligne==4 then
                  reponse= Confirmer("Quit", "Save document,", "continue?", "Save", "Do not save")
                  if reponse=="annuler" then
                     return false
                  end
                  if reponse then
                     dossier_en_cours= System.currentDirectory()
                     statut.etat= "Enregistrer"
                     Enregistrer()
                     statut.etat= "rien"
                  end
                  if option.hex then
                     f_hex:close()
                  end
                  Sauv_parametres()
                  return true
               end
            end
         elseif col==2 then
            if ligne==1 then
               if option.coloration then
                  option.coloration= false
                  syntax= nil
               elseif not option.hex then
                  Detect_com()
                  option.coloration= true
                  syntax= {{},{"do","if","in","or"},{"and","end","for","nil","not"},{"else","then","true"},{"break","false","local","while"},{"return"},{},{"function"}}
               end
            elseif ligne==2 then
               if option.numero_lignes then
                  option.numero_lignes= false
               elseif not option.hex then
                  option.numero_lignes= true
                  option.scroll= false
               end
            elseif ligne==3 then
               if option.scroll then
                  option.scroll= false
               else
                  option.numero_lignes= false
                  option.scroll= true
               end
            elseif ligne==4 then
               if option.autocomp then
                  option.autocomp= false
                  AutoC= nil
               elseif not option.hex then
                  aide= {}
                  Help= nil
                  option.aide= false
                  option.autocomp= true
                  do
                     local dire= System.currentDirectory(dos.."Applications/lowser")
                     dofile("AutoCompletion.lua")
                     System.currentDirectory(dire)
                  end
                  Ajouter_fct()
               end
            elseif ligne==5 then
               if option.aide then
                  option.aide= false
                  Help= nil
               elseif not option.hex then
                  AutoC= nil
                  do
                     local dire= System.currentDirectory(dos.."Applications/lowser")
                     dofile("aide_help.lua")
                     System.currentDirectory(dire)
                  end
                  statut.val[7][2]= true
                  statut.val[7][1]= 1
                  option.autocomp= false
                  option.aide= true
               end   
            elseif ligne==6 then
               Choisir_couleur()
            end
         elseif col==3 then
            if ligne==1 then
               Afficher_aide()
            elseif ligne==2 then
               Credit()
            elseif ligne==3 then
               Init_autoc()
            Ajouter_fct()
            elseif ligne==4 then
               Credit()
            end
         end
         return
      end
      if col==1 then
         screen:blit(3, 3, image.bouton)
         screen:blit(3, 27, image.fichier)
         for i= 1, table.getn(menu[1]) do
            screen:fontPrint(police, 10, i*20+22, menu[1][i], couleur.texte)
         end
         screen:fontPrint(police, 13, 19, "File", couleur.texte)
         screen:fontPrint(police, 10, ligne*20+22, menu[1][ligne], couleur.rouge)
      elseif col==2 then
         screen:blit(81, 3, image.bouton)
         screen:blit(81, 27, image.option)
         for i= 1, table.getn(menu[2]) do
            screen:fontPrint(police, 88, i*20+22, menu[2][i], couleur.texte)
         end
         screen:fontPrint(police, 91, 19, "Options", couleur.texte)
         screen:fontPrint(police, 88, ligne*20+22, menu[2][ligne], couleur.rouge)
      elseif col==3 then
         screen:blit(165, 3, image.bouton)
         screen:blit(165, 27, image.aide)
         for i= 1, table.getn(menu[3]) do
            screen:fontPrint(police, 172, i*20+22, menu[3][i], couleur.texte)
         end
         screen:fontPrint(police, 179, 19, "Help", couleur.texte)
         screen:fontPrint(police, 172, ligne*20+22, menu[3][ligne], couleur.rouge)    
      end
      oldpad= pad
      pad= Controls.read()
      screen.waitVblankStart()
      screen.flip()
      if pad:select() then
         break
      end
   end
   while pad:select() do
      pad= Controls.read()
   end
end


function Sauter()
   local taille= table.getn(save)
   if pad:up() then
      cadre.y= 1
      cadre.x= 0
      curseur.y= 0
      curseur.y= 0
      if option.hex then
         Charger_bloc()
      end
      return true
   end
   if pad:square() then
      cadre.x= 0
      curseur.x= 0
      if option.hex then
         Charger_bloc()
      end
      return true
   end
   if pad:circle() then
      if option.hex then
         curseur.x= 60-option.decalage
         cadre.x= 67-60+option.decalage
         Charger_bloc()
      else
         cadre.x= 0
         curseur.x= string.len(save[cadre.y+curseur.y])
         if curseur.x>60-option.decalage then
            curseur.x= 60-option.decalage
            cadre.x= string.len(save[curseur.y+cadre.y])-(60-option.decalage)
         end
      end
      return true
   end
   if pad:down() then
      if option.hex then
         if math.ceil(f_hex:seek("end")/16)>22 then
            cadre.y= math.ceil(f_hex:seek("end")/16)-22
            curseur.y= 22
         else
            cadre.y= 0
            curseur.y= math.ceil(f_hex:seek("end")/16)-22
         end
         curseur.x= 60-option.decalage
         cadre.x= 67-60+option.decalage
         Charger_bloc()
      else
         cadre.y= taille-22
         curseur.y= 22
         cadre.x= 0
         curseur.x= string.len(save[taille])
         if curseur.x>60-option.decalage then
            curseur.x= 60-option.decalage
            cadre.x= string.len(save[taille])-(60-option.decalage)
         end
         if cadre.y<1 then
            cadre.y= 1
            curseur.y= taille
         end
      end
      return true
   end
   if pad:left() then
      cadre.y= cadre.y-23
      if cadre.y<1 then
         cadre.y= 1
      end
      cadre.x= 0
      curseur.x= 0
      curseur.y= 0
      if option.hex then
         Charger_bloc()
      end
      return true
   end
   if pad:right() then
      cadre.y= cadre.y+23
      curseur.y= 22
      cadre.x= 0
      curseur.x= 0
      if option.hex then
         if cadre.y>math.ceil(f_hex:seek("end")/16)-22 then
            cadre.y= math.ceil(f_hex:seek("end")/16)-22
            if cadre.y<1 then
               cadre.y= 1
               curseur.y= math.ceil(f_hex:seek("end")/16)
            end
         end
         Charger_bloc()
      else
         if cadre.y>taille-22 then
            cadre.y= taille-22
            if cadre.y<1 then
               cadre.y= 1
               curseur.y= taille
            end
         end
      end
      return true
   end
   return false
end


function Chercher()
   local var, X1, X2
   if statut.var==1 then
      X1= 0
      X2= 0   
   end
   if statut.val[1]~=nil then
      statut.msg= 'Search for \"'..statut.val[1]..'\"'
      statut.val[8]= statut.val[1]
   else
      statut.var= 2
      statut.msg= 'Search for \"\"'
   end
   if pad:select() and not oldpad:select() and copie~=nil and table.getn(copie)>0 then
      statut.val[1]= copie[1]
      statut.var= 2
   end
   if pad:up() and not oldpad:up() then
      statut.var= 2
      statut.val[2]= " with breaks"
   end
   if pad:down() and not oldpad:down() then
      statut.var= 2
      statut.val[2]= " without breaks"
   end
   statut.msg= statut.msg..statut.val[2]
   if pad:start() then
      statut.var= 0
      option.clavier= false
      statut.etat= "rien"
      Msg()
      while pad:start() do
         pad= Controls.read()
      end
   end
   if statut.val[1]==nil then
      return
   end
   if pad:left() and not oldpad:left() and not pad:r() then
      statut.var= 3
      for i= statut.val[4], 1, -1 do
         for j= statut.val[3], 1, -1 do
            if statut.val[2]==" with breaks" then
               var= string.find(string.sub(save[i], 1, statut.val[3]), string.gsub(statut.val[1], "([%^%$%(%)%[%]])", function(w) return "%"..w end), j)
            else
               var= string.find(string.lower(string.sub(save[i], 1, statut.val[3])), string.lower(string.gsub(statut.val[1], "([%^%$%(%)%[%]])", function(w) return "%"..w end)), j)
            end
            if var~=nil then
               statut.val[4]= i
               statut.val[3]= var-1
               statut.var= 4
               break
            end
         end
         if var~=nil then
            break
         else
            if i>1 then
               statut.val[3]= string.len(save[i-1])
            end
         end
      end
   end
   if pad:right() and oldpad:right()~=pad:right() and string.len(statut.val[1])>0 then
      statut.var= 3
      for i= statut.val[4], table.getn(save) do
         if statut.val[2]==" with breaks" then
            var= string.find(save[i], string.gsub(statut.val[1], "([%[%]%(%)%{%}])", function(w) return "%"..w end), statut.val[3])
         else
            var= string.find(string.lower(save[i]), string.lower(string.gsub(statut.val[1], "([%[%]%(%)%{%}])", function(w) return "%"..w end)), statut.val[3])
         end
         if var~=nil then
            statut.val[4]= i
            statut.val[3]= var+1
            statut.var= 4
            break
         else
            statut.val[3]= 1
         end
      end
   end
   if var~=nil then
      statut.val[5]= {}
      cadre.y= statut.val[4]
      statut.val[5][1]= var+option.decalage-1
      statut.val[5][2]= string.len(statut.val[1])
      if statut.val[5][1]+statut.val[5][2]>60-option.decalage then
         cadre.x= statut.val[5][1]-60+option.decalage+statut.val[5][2]
         statut.val[5][1]= 60-option.decalage-statut.val[5][2]
         statut.val[5][2]= string.len(statut.val[1])
      else
         cadre.x= 0
      end
      curseur.x= statut.val[5][1]-option.decalage
      curseur.y= 0
      cadre.y= statut.val[4]
   end
   if statut.var==3 then
      statut.msg= statut.msg.." (done)"
   end
end


function Goto()
   local ligne= 0
   
   if statut.val[1]~=nil then
      ligne= statut.val[1]-'0'
   else
      ligne= 0
   end
   statut.msg= "Goto line "..ligne
   if pad:left() or pad:start() then
      while pad:start() do
         pad= Controls.read()
      end
      option.clavier= false
      option.type= statut.val[2]
      option.type2= statut.val[3]
      statut.etat= statut.val[5]
      if option.hex then
         statut.etat= "rien"
      end
      Msg()
      return
   end
   if (pad:r() and not oldpad:r()) or (pad:right() and not oldpad:right()) then
      statut.etat= statut.val[5]
      option.clavier= false
      if ligne==0 then
         option.clavier= false
         option.type= statut.val[2]
         option.type2= statut.val[3]
        statut.etat= statut.val[5]
         if option.hex then
            statut.etat= "rien"
         end
         Msg()
         return
      end
      if option.hex then
         if ligne<=f_hex:seek("end")/16 then
            curseur.x= 0
            curseur.y= 0
            cadre.x= 0
            cadre.y= ligne
            Charger_bloc()
         end
      else
         if ligne<=table.getn(save) then
            curseur.x= 0
            curseur.y= 0
            cadre.x= 0
            cadre.y= ligne
         end
      end
      option.type= statut.val[2]
      option.type2= statut.val[3]
      statut.etat= statut.val[5]
      if option.hex then
         statut.etat= "rien"
      end
      Msg()
   end
end


function Log2(a)
   return math.log(a)/math.log(2)
end


function KB_Read_Mask(value, lim, table)
   if lim>1 then
      if value>=lim then
         table[math.ceil(math.log(lim)/math.log(2))]= true
         KB_Read_Mask(value-lim, lim/2, table)
      else
         table[math.ceil(math.log(lim)/math.log(2))]= false
         KB_Read_Mask(value, lim/2, table)
      end
   else
      return
   end
end


function rect(x1, y1, x2)
   if y1<0 then
      return
   end
   if x1-option.decalage<0 then
      x1= option.decalage
   end
   if x2>60-option.decalage then
      x2= 60-option.decalage
   end
   screen:fillRect(x1*8, (y1)*10+29, x2*8, 8, couleur.rouge)
end


function Selectionner()
   if statut.var==0 then
      statut.val[1]= curseur.x
      statut.val[2]= cadre.x
      statut.val[3]= curseur.y
      statut.val[4]= cadre.y
      statut.var= 1
   end
   if statut.var~=4 then
      statut.msg= "Selecting..."
   end
   if curseur.y+cadre.y<statut.val[3]+statut.val[4] then
      if string.len(save[curseur.y+cadre.y])~=nil then
         rect(curseur.x+option.decalage, curseur.y, string.len(save[curseur.y+cadre.y])-(cadre.x+curseur.x))
      end
      for i= curseur.y+cadre.y+1, statut.val[3]+statut.val[4]-1 do
         if i-cadre.y>22 then
            break
         end
         if save[i]~=nil then
            rect(option.decalage, i-cadre.y, string.len(save[i])-cadre.x)
         end
      end
      if statut.val[3]+statut.val[4]-(curseur.y+cadre.y)+curseur.y<23 then
         rect(option.decalage, statut.val[3]+statut.val[4]-cadre.y, statut.val[1]+statut.val[2]-cadre.x)
      end
   elseif curseur.y+cadre.y>statut.val[3]+statut.val[4] then
      if save[statut.val[3]+statut.val[4]]~=nil then
         rect(statut.val[1]+statut.val[2]-cadre.x+option.decalage, statut.val[3]+statut.val[4]-cadre.y, string.len(save[statut.val[3]+statut.val[4]])-(statut.val[1]+statut.val[2]))
      end
      for i= statut.val[3]+statut.val[4]+1, curseur.y+cadre.y-1 do
         if i-cadre.y>=0 then
            if save[i]~=nil then
               rect(option.decalage, i-cadre.y, string.len(save[i])-cadre.x)
            end
         end
      end
      rect(option.decalage, curseur.y, curseur.x)
   else
      if cadre.x+curseur.x<statut.val[1]+statut.val[2] then
         rect(curseur.x+option.decalage, curseur.y, statut.val[1]+statut.val[2]-(cadre.x+curseur.x))
      else
         rect(statut.val[1]+statut.val[2]-cadre.x+option.decalage, curseur.y, curseur.x+cadre.x-(statut.val[1]+statut.val[2]))
      end
   end
end


function Indenter(sens)
   local tmp_y, tmp_y2, tmp_x, tmp_x2, j
   if statut.etat=="Selection" then
      if statut.val[3]+statut.val[4]>curseur.y+cadre.y then
         tmp_y= curseur.y+cadre.y
         tmp_y2= statut.val[3]+statut.val[4]
         tmp_x= curseur.x+cadre.x
         tmp_x2= statut.val[1]+statut.val[2]
      elseif statut.val[3]+statut.val[4]<curseur.y+cadre.y then
         tmp_y= statut.val[3]+statut.val[4]
         tmp_y2= curseur.y+cadre.y
         tmp_x= curseur.x+cadre.x
         tmp_x2= statut.val[1]+statut.val[2]
      else
         tmp_y= curseur.y+cadre.y
         tmp_y2= tmp_y
      end
   else
      tmp_y= curseur.y+cadre.y
      tmp_y2= tmp_y
      tmp_x= curseur.x+cadre.x
      tmp_x2= tmp_x
   end
   if sens==1 then
      for i= 0, tmp_y2-tmp_y do
         save[i+tmp_y]= "   "..save[i+tmp_y]
      end
   elseif sens==2 then
      for i= 0, tmp_y2-tmp_y do
         for j= 1, 3 do
            if string.sub(save[i+tmp_y], 1, 1)==" " then
               save[i+tmp_y]= string.sub(save[i+tmp_y], 2)
            end
         end
      end
   end
end


function Sauver()
   local tmp_x, tmp_x2, tmp_y, tmp_y2
   copie= {}   

   if statut.val[3]+statut.val[4]>curseur.y+cadre.y then
      tmp_y= curseur.y+cadre.y
      tmp_y2= statut.val[3]+statut.val[4]
      tmp_x= statut.val[1]+statut.val[2]
      tmp_x2= curseur.x+cadre.x+1
   elseif statut.val[3]+statut.val[4]<curseur.y+cadre.y then
      tmp_y= statut.val[3]+statut.val[4]
      tmp_y2= curseur.y+cadre.y
      tmp_x= curseur.x+cadre.x
      tmp_x2= statut.val[1]+statut.val[2]+1
   else
      tmp_y= curseur.y+cadre.y
      tmp_y2= tmp_y
      if curseur.x+cadre.x<statut.val[1]+statut.val[2] then
         tmp_x= curseur.x+cadre.x
         tmp_x2= statut.val[1]+statut.val[2]
      elseif curseur.x+cadre.x>=statut.val[1]+statut.val[2] then
         tmp_x= statut.val[1]+statut.val[2]
         tmp_x2= curseur.x+cadre.x
      end
   end
   if tmp_y~=tmp_y2 then
      if save[tmp_y]~=nil then
         table.insert(copie, 1, string.sub(save[tmp_y], tmp_x2) )
      end
      for i= 2, tmp_y2-tmp_y do
         table.insert(copie, i, save[tmp_y+i-1])
      end
      if save[tmp_y2]~=nil then
         table.insert(copie, tmp_y2-tmp_y+1, string.sub(save[tmp_y2], 1, tmp_x) )
      end
   else
      table.insert(copie, 1, string.sub(save[tmp_y], tmp_x+1, tmp_x2) )
   end
end


function Coller()
   local str_debut, str_fin
   tmp_x= curseur.x+cadre.x
   tmp_y= curseur.y+cadre.y

   if copie==nil or table.getn(copie)<=0 then
      return
   end
   if table.getn(copie)>1 then
      if save[tmp_y]~=nil and copie[1]~=nil then
         str_debut= string.sub(save[tmp_y], 0, tmp_x)..copie[1]
         str_fin= copie[table.getn(copie)]..string.sub(save[tmp_y], tmp_x+1)
      elseif save[tmp_y]~=nil then
         str_debut= string.sub(save[tmp_y], 0, tmp_x)
         str_fin= string.sub(save[tmp_y], tmp_x+1)
      else
         str_debut= nil
         str_fin= nil
      end
      save[tmp_y]= str_fin
      for i= table.getn(copie)-1, 2, -1 do
         table.insert(save, tmp_y, copie[i])
      end
      table.insert(save, tmp_y, str_debut)
   else
      if save[tmp_y]~=nil then
         str_debut= string.sub(save[tmp_y], 0, tmp_x)..copie[1]..string.sub(save[tmp_y], tmp_x+1)
      end
      save[tmp_y]= str_debut
   end

   if table.getn(copie)-1>22-curseur.y then
      cadre.y= cadre.y+table.getn(copie)-23+curseur.y
      curseur.y= 22
   else
      curseur.y= curseur.y+table.getn(copie)-1
   end
   if table.getn(copie)>1 then
      if copie[table.getn(copie)]~=nil then
         curseur.x= string.len(copie[table.getn(copie)])
      else
         curseur.x= 0
      end
   else
      if copie[1]~=nil then
         curseur.x= tmp_x+string.len(copie[1])
      else
         curseur.x= tmp_x
      end
   end
   if curseur.x+option.decalage>60 then
      cadre.x= curseur.x-(60-option.decalage)
      curseur.x= 60-option.decalage
   end
end


function Supprimer_sel()
   local tmp_x2, tmp_x, tmp_y, tmp_y2
   local str= ""

   if statut.val[3]+statut.val[4]>curseur.y+cadre.y then
      tmp_y= curseur.y+cadre.y
      tmp_y2= statut.val[3]+statut.val[4]
      tmp_x= curseur.x+cadre.x
      tmp_x2= statut.val[1]+statut.val[2]
   elseif statut.val[3]+statut.val[4]<curseur.y+cadre.y then
      tmp_y= statut.val[3]+statut.val[4]
      tmp_y2= curseur.y+cadre.y
      tmp_x= statut.val[1]+statut.val[2]
      tmp_x2= curseur.x+cadre.x
   else
      tmp_y= curseur.y+cadre.y
      tmp_y2= tmp_y
      if curseur.x+cadre.x<statut.val[1]+statut.val[2] then
         tmp_x= curseur.x+cadre.x
         tmp_x2= statut.val[1]+statut.val[2]
      elseif curseur.x+cadre.x>=statut.val[1]+statut.val[2] then
         tmp_x= statut.val[1]+statut.val[2]
         tmp_x2= curseur.x+cadre.x
      end
   end
   statut.etat= "rien"
   statut.var= 0
   if tmp_x==tmp_x2 and tmp_y==tmp_y2 then
      Effacer()
      return
   end
   if save[tmp_y]~=nil then
      str= string.sub(save[tmp_y], 0, tmp_x)
   else
      str= nil
   end
   if save[tmp_y2]~=nil then
      str= str..string.sub(save[tmp_y2], tmp_x2+1)
   end
   for i= 0, tmp_y2-tmp_y do
      table.remove(save, tmp_y)
   end
   table.insert(save, tmp_y,  str)
   if curseur.x+cadre.x~=tmp_x or curseur.y+cadre.y~=tmp_y then
      curseur.x= statut.val[1]
      cadre.x= statut.val[2]
      if curseur.y+cadre.y<statut.val[3]+statut.val[4] or curseur.y+cadre.y>statut.val[3]+statut.val[4]+23 then
         curseur.y= statut.val[3]
         cadre.y= statut.val[4]
      else
         curseur.y= statut.val[3]+statut.val[4]-cadre.y
      end
      VerifierX()
      VerifierY()
   end
   Creer_curseur()
end


function Raccourcis()
   local sel= 1
   local assignation= false
   local color= couleur.bleu

   while pad:select() do
      pad= Controls.read()
   end
   while true do
      pad= Controls.read()
      if assignation then
         do
            local temp= {}

            temp[1]= touches[sel][2]
            temp[2]= touches[sel][3]
            if pad:select() and not oldpad:select() then
               assignation= false
            end
            if pad:l() then
               touches[sel][2]= Controls.ltriggerMask
            elseif pad:r() then
               touches[sel][2]= Controls.rtriggerMask
            end
            if pad:up() then
               touches[sel][3]= Controls.upMask
            elseif pad:down() then
               touches[sel][3]= Controls.downMask
            elseif pad:left() then
               touches[sel][3]= Controls.leftMask
            elseif pad:right() then
               touches[sel][3]= Controls.rightMask
            elseif pad:circle() then
               touches[sel][3]= Controls.circleMask
            elseif pad:triangle() then
               touches[sel][3]= Controls.triangleMask
            elseif pad:square() then
               touches[sel][3]= Controls.squareMask
            elseif pad:cross() then
               touches[sel][3]= Controls.crossMask
            end
            for i= 1, table.getn(touches)-1 do
               for j= i+1, table.getn(touches) do
                  if touches[j][2]==touches[i][2] and touches[j][3]==touches[i][3] then
                     if j==sel then
                        touches[i][2]= temp[1]
                        touches[i][3]= temp[2]
                     elseif i==sel then
                        touches[j][2]= temp[1]
                        touches[j][3]= temp[2]
                     end
                  end
               end
            end
         end
      else
         if pad:select() and not oldpad:select() then
            assignation= true
            while pad:select() do
               pad= Controls.read()
            end
         end
         if pad:r() then

            break
         end
         if pad:l() then
            return
         end
         if pad:down() and not oldpad:down() then
            sel= sel+1
         end
         if pad:up() and not oldpad:up() then
            sel= sel-1
         end
         if sel<1 then
            sel= table.getn(touches)
         end
         if sel>table.getn(touches) then
            sel= 1
         end
      end 
      screen:clear(couleur.noir)
      screen:fillRect(0, 0, 480, 29, couleur.mauve)
      screen:fillRect(1, 1, 478, 27, couleur.gris)
      screen:print(216, 10, "SHORTCUTS", couleur.blanc)
      for i= 1, table.getn(touches) do
         screen:print(30, 15*i+50, touches[i][1]..":", couleur.blanc)
         screen:print(200, 15*i+50, Touche(touches[i][2]), couleur.blanc)
         if touches[i][3] then
            screen:print(208, 15*i+50, " + "..Touche(touches[i][3]), couleur.blanc)
         end
      end
      if assignation then
         color= couleur.rouge
      else
         color= couleur.bleu
      end
      screen:print(30, 15*sel+50, touches[sel][1]..":", color)
      screen:print(200, 15*sel+50, Touche(touches[sel][2]), color)
      if touches[sel][3] then
         screen:print(208, 15*sel+50, " + "..Touche(touches[sel][3]), color)
      end
      screen.waitVblankStart()
      screen.flip()
      oldpad= pad
   end
   while pad:r() do
      pad= Controls.read()
   end
end


function Touche(a)
   if a==Controls.ltriggerMask then
      return "L"
   elseif a==Controls.rtriggerMask then
      return "R"
   elseif a==Controls.upMask then
      return "up"
   elseif a==Controls.downMask then
      return "down"
   elseif a==Controls.leftMask then
      return "left"
   elseif a==Controls.rightMask then
      return "right"
   elseif a==Controls.circleMask then
      return "circle"
   elseif a==Controls.triangleMask then
      return "triangle"
   elseif a==Controls.squareMask then
      return "square"
   elseif a==Controls.crossMask then
      return "cross"
   end
   return ""
end


function Curseur()
   local mouv= 0

   if pad:right() and (not oldpad:right() or option.compteur>=5) then
      curseur.x= curseur.x+1
      if option.autocomp then
         statut.val[7]= {1, 0}
      end
   end
   if pad:left() and (not oldpad:left() or option.compteur>=5) then
      curseur.x= curseur.x-1
      if option.autocomp then
         statut.val[7]= {1, 0}
      end
   end
   if pad:down() and (not oldpad:down() or option.compteur>=5) then
      mouv= {statut.val[7][1], statut.val[7][2]}
      if option.autocomp and option.clavier then
         statut.val[7][2]= statut.val[7][2]+1
         if statut.val[7][2]>6 then
            statut.val[7][2]= 6
            statut.val[7][1]= statut.val[7][1]+1
            if statut.val[7][2]+statut.val[7][1]>=table.getn(statut.val[6]) then
               statut.val[7]= {1, 0}
            end
         end
         if statut.val[7][2]>=table.getn(statut.val[6]) then
            statut.val[7]= {1, 0}
         end
         if (mouv[1]~=statut.val[7][1] or mouv[2]~=statut.val[7][2]) and table.getn(statut.val[6])>1 then
            return
         end
         mouv= 0
      elseif option.aide then
         mouv= statut.val[7][1]
         if table.getn(statut.val[6])-statut.val[7][1]>=12 then
            statut.val[7][1]= statut.val[7][1]+1
         end
         if mouv~=statut.val[7][1] then
            return
         else
            statut.val[7][1]= 1
         end
         mouv= 0
      end
      curseur.y= curseur.y+1
      mouv= 1
   end
   if pad:up() and (not oldpad:up() or option.compteur>=5) then
      if option.autocomp and option.clavier then
         mouv= {statut.val[7][1], statut.val[7][2]}
         statut.val[7][2]= statut.val[7][2]-1
         if statut.val[7][2]<0 then
            if statut.val[7][1]>1 then
               statut.val[7][1]= statut.val[7][1]-1
               statut.val[7][2]= 0
            else
               statut.val[7][1]= table.getn(statut.val[6])-7
               statut.val[7][2]= 6
               if statut.val[7][1]<1 then
                  statut.val[7][1]= 1
                  statut.val[7][2]= table.getn(statut.val[6])-1
               end
            end
         end
         if (mouv[1]~=statut.val[7][1] or mouv[2]~=statut.val[7][2]) and table.getn(statut.val[6])>1 then
            return
         end
         mouv= 0
      elseif option.aide then
         mouv= statut.val[7][1]
         if statut.val[7][1]>1 then
            statut.val[7][1]= statut.val[7][1]-1
         end
         if mouv~=statut.val[7][1] then
            return
         else
            statut.val[7][1]= 1
         end
         mouv= 0
      end
      curseur.y= curseur.y-1
      mouv= -1
   end
   if not option.clavier then
      if pad:analogX()>50 then
         curseur.x= curseur.x+1
      end
      if pad:analogX()<-50 then
         curseur.x= curseur.x-1
      end
      if pad:analogY()>50 then
         curseur.y= curseur.y+1
         mouv= 1
      end
      if pad:analogY()<-50 then
         curseur.y= curseur.y-1
         mouv= -1
      end
   end
   if option.hex then
      VerifierY_(mouv)
      VerifierX_(mouv)
   else
      VerifierY(mouv)
      VerifierX(mouv)
   end
end


function VerifierX(mouv)
   if curseur.x<0 then
      if cadre.x>1 then
         curseur.x= 0
         cadre.x= cadre.x-1
      else
         if curseur.y>0 then
            curseur.y= curseur.y-1
            VerifierY()

            if save[curseur.y+cadre.y]=="" or save[curseur.y+cadre.y]==nil then
               curseur.x= 0
            else
               cadre.x= 0
               curseur.x= string.len(save[curseur.y+cadre.y])
               if curseur.x>59-option.decalage then
                  curseur.x= 59-option.decalage
                  cadre.x= string.len(save[curseur.y+cadre.y])-(60-option.decalage)
               end
               VerifierX()
            end
         else
            if cadre.y>1 then
               cadre.y= cadre.y-1
               curseur.x= string.len(save[curseur.y+cadre.y])
               if curseur.x>60-option.decalage then
                  curseur.x= 60-option.decalage
                  cadre.x= string.len(save[curseur.y+cadre.y])-(60-option.decalage)
               end
            else
               curseur.x= 0
            end
         end
      end
   end
   if save[curseur.y+cadre.y]~=nil then
      if curseur.x+cadre.x>string.len(save[curseur.y+cadre.y]) then
         if mouv==0 then
            curseur.y= curseur.y+1
            VerifierY()
            curseur.x= 0
            cadre.x= 0
         else
            cadre.x= 0
            curseur.x= string.len(save[curseur.y+cadre.y])
            if curseur.x>60-option.decalage then
               curseur.x= 60-option.decalage
               cadre.x= string.len(save[curseur.y+cadre.y])-(60-option.decalage)
            end
         end
      end
   end
   if curseur.x>59-option.decalage then
      curseur.x= 59-option.decalage
      cadre.x= cadre.x+1
      VerifierX()
   end
end


function VerifierY(mouv)
   if curseur.y<0 then
      if cadre.y>1 then
         cadre.y= cadre.y-1
      else
         curseur.x= 0
         cadre.x= 0
      end
      curseur.y= 0
   end
   if curseur.y>22 then
      if cadre.y+22<table.getn(save) then
         cadre.y= cadre.y+1
      end
      curseur.y= 22
   end
   if option.clavier then
      if curseur.y>6 then
         cadre.y= cadre.y+curseur.y-6
         curseur.y= 6
      end
   end
   if curseur.y+cadre.y>=table.getn(save) then
      cadre.y= table.getn(save)-22
      curseur.y= 22
      if table.getn(save)<23 then
         cadre.y= 1
         curseur.y= table.getn(save)-1
      end
   end
end


function Inserer_texte(texte, string)
   if option.coloration and texte=="[" then
      Detect_com()
   end
   if string==nil then
      string= texte
   else
      local debut= string.sub(string, 0, curseur.x+cadre.x)
      local fin= string.sub(string, curseur.x+cadre.x+1)

      string= debut..texte..fin
      curseur.x= curseur.x+string.len(texte)
   end

   return string
end


function Effacer()
   if option.hex and statut.etat=="rien" then
      return
   end
   if statut.etat=="Goto" or statut.etat=="Chercher" then
      statut.var= 2
      statut.val[1]= string.sub(statut.val[1], 0, string.len(statut.val[1])-1)
      return
   end
   if statut.etat=="Enregistrer" then
      if curseur.x<1 then
         return
      end
      local debut= string.sub(statut.val[1], 0, curseur.x+cadre.x-1)
      local fin= string.sub(statut.val[1], curseur.x+cadre.x+1)

      statut.val[1]= debut..fin
      curseur.x= curseur.x-1
      return
   end

   local caractere= string.sub(save[curseur.y+cadre.y], curseur.x+cadre.x, curseur.x+cadre.x)
   if option.coloration and (caractere=="]" or caractere=="[" or caractere=="-")then
      Detect_com()
   end
   if save[curseur.y+cadre.y]==nil then
   elseif curseur.x+cadre.x==0 then
      if curseur.y+cadre.y>1 then
         Supprimer_ligne()
         if option.coloration then
            Detect_com()
         end
      end
   else
      local debut= string.sub(save[curseur.y+cadre.y], 0, curseur.x+cadre.x-1)
      local fin= string.sub(save[curseur.y+cadre.y], curseur.x+cadre.x+1)

      save[curseur.y+cadre.y]= debut..fin
      curseur.x= curseur.x-1
      VerifierX()
   end
end


function Inserer_ligne()
   local debut, fin= string.sub(save[curseur.y+cadre.y], 0, curseur.x+cadre.x), string.sub(save[curseur.y+cadre.y], curseur.x+cadre.x+1)
   
   if statut.val[1]=="Goto" or statut.etat=="Chercher" then
      return
   end   
   save[curseur.y+cadre.y]= debut
   debut= ""
   for i= 1, string.len(save[curseur.y+cadre.y]) do
      if string.sub(save[curseur.y+cadre.y], i, i)==" " then
         debut= debut.." "
      else
         break
      end
   end
   curseur.x= string.len(debut)
   cadre.x= 0
   fin= debut..fin
   table.insert(save, curseur.y+cadre.y+1, fin)
   VerifierX()
   curseur.y= curseur.y+1
   VerifierY()
   Creer_curseur()
end


function Supprimer_ligne()
   local debut= save[curseur.y+cadre.y-1]
   local fin= save[curseur.y+cadre.y]

   curseur.x= string.len(save[curseur.y+cadre.y-1])
   table.remove(save, curseur.y+cadre.y)
   save[curseur.y+cadre.y-1]= debut..fin
   if curseur.x>60-option.decalage then
      if string.len(fin)>59-option.decalage then
         curseur.x= 59-option.decalage
         cadre.x= string.len(debut)-(59-option.decalage)
      else
         curseur.x= 59-string.len(fin)-option.decalage
         cadre.x= string.len(save[curseur.y+cadre.y-1])-(59-option.decalage)
      end
   end
   curseur.y= curseur.y-1
   VerifierY()
   Creer_curseur()
end


function Process()
   for i=1, table.getn(save) do
      if string.find(save[i], "\t", 1)~=nil then
         save[i]= string.gsub(save[i], "\t", "   ")
      end
      if string.sub(save[i], string.len(save[i]))=="\r" then
         save[i]= string.sub(save[i], 0, string.len(save[i]) - 1)
      end
   end
end


function Batterie(P)
   local img, transparent
   img= Image.createEmpty(image.batt1:width(), image.batt1:height())
   transparent= img:pixel(0, 0)
   img:blit(0, 0, image.batt1)
   img:fillRect(0, 0, img:width()*(100-P)/100, img:height()-1, transparent)
   img:blit(0, 0, image.batt2)
   screen:blit(330, 3, img)
   if System.powerIsBatteryCharging() then
      screen:print(333, 18, P.."%", couleur.rouge)
   else
      screen:print(333, 18, P.."%", couleur.texte)
   end
end


function Afficher()
   local img

   screen:clear(couleur.blanc)
   screen:blit(0, 0, image.bg)
--[[   screen:drawLine(0, 0, 480, 0, couleur.noir)
   screen:drawLine(480, 1, 480, 26, couleur.noir)
   screen:drawLine(0, 26, 479, 26, couleur.noir)
   screen:drawLine(0, 1, 0, 25, couleur.noir)
   screen:drawLine(0, 272, 480, 272, couleur.noir)
   screen:drawLine(480, 271, 480, 258, couleur.noir)
   screen:drawLine(0, 258, 479, 258, couleur.noir)
   screen:drawLine(0, 271, 0, 259, couleur.noir)]]
   screen:print(3, 260, statut.msg, couleur.texte)
   if option.numero_lignes then
      screen:fillRect(0, 27, 8*option.decalage, 231, couleur.gris)
      screen:blit(curseur.x*8 + (8*option.decalage), curseur.y * 10 + 29, image.curseur)
   elseif option.scroll then
      Scroll()
      screen:blit(curseur.x*8 + (8*option.decalage), curseur.y * 10 + 29, image.curseur)
   else
      screen:blit(curseur.x*8, curseur.y * 10 + 29, image.curseur)
   end
   if statut.etat=="Selection" then
      Selectionner()
   end
   if statut.etat=="Chercher" and statut.var==4 then
      rect(statut.val[5][1], 0, statut.val[5][2])
   end
   if option.hex then
      do
         local x= cadre.x+curseur.x
         if x>50 and x<67 then
            screen:fillRect(((x-51)*3+option.decalage-cadre.x)*8, curseur.y*10+28, 15, 9, couleur.rouge)
         end
         if x<47 then
            x= math.ceil((cadre.x+curseur.x-2)/3)
            screen:fillRect((51+x+option.decalage-cadre.x)*8, curseur.y*10+28, 8, 9, couleur.rouge)
         end
      end
   end
   if option.coloration then
      Afficher_texteC(cadre.y)
   else
      Afficher_texte(cadre.y)
   end
   if option.autocomp then
      if option.clavier and statut.etat=="rien" then
         img= AutoCompletion()
         screen:blit((323-img:width())/2, 150, img)
      end
      screen:blit(260, 2, image.ac)
   end
   if option.aide then
      if statut.val[7][2]==true then
         screen:blit(0, 136, Aide_online())
      end
      screen:blit(256, 2, image.help)
   end
   do
      local dateFields= os.date("*t", os.time())
      local hour= dateFields.hour
   
      if hour<10 then
         hour= "0" .. hour
      end
      local min= dateFields.min
   
      if min<10 then
         min= "0" .. min
      end
      screen:print(286, 10, hour.."h"..min, couleur.texte)
   end
   Batterie(System.powerGetBatteryLifePercent())
   if option.hex then
      screen:print(364, 10, string.format("%014d", cadre.y+curseur.y), couleur.texte)
   else
      screen:print(390-(math.floor(math.log10(cadre.y+curseur.y))*8)-(math.floor(math.log10(cadre.x+curseur.x+1))*8), 10, " Ln "..cadre.y+curseur.y..";Col "..cadre.x+curseur.x, couleur.texte)
   end
end


function Assigner_texte()
   if option.hex then
      for i=1, 23 do
         if save[i]~=nil then
            lignes[i]= string.sub(save[i], cadre.x+1)
         else
            lignes[i]= nil
         end
      end
      return
   end
   for i=cadre.y, cadre.y+22 do
      if save[i]~=nil then
         lignes[i - cadre.y + 1]= string.sub(save[i], cadre.x + 1)
      else
         lignes[i - cadre.y + 1]= nil
      end
   end
end


function Creer_img()
   local dire= System.currentDirectory(dos.."Applications/lowser")

   screen:clear()
   screen:print(152, 128, "Loading...", couleur.blanc)
   screen.flip()
      
   image.clavier= Image.createEmpty(151, 151)
   image.clavier:clear(couleur.perso)
   image.clavier:blit(0, 0, Image.load("img/clavier1.png"))
   image.clavier1= Image.createEmpty(151, 151)
   image.clavier1:clear(couleur.perso)
   image.clavier1:blit(0, 0, Image.load("img/clavier2.png"))
   image.clavier2= Image.createEmpty(151, 151)
   image.clavier2:clear(couleur.perso)
   image.clavier2:blit(0, 0, Image.load("img/clavier3.png"))
   image.clavier3= Image.createEmpty(151, 151)
   image.clavier3:clear(couleur.perso)
   image.clavier3:blit(0, 0, Image.load("img/clavier4.png"))
   
   image.bg= Image.createEmpty(480, 272)
   image.bg:clear(couleur.perso)
   image.bg:blit(0, 0, Image.load("img/bg1.png"))
   if option.bg=="bg2" then
      image.bg:blit(0, 27, Image.load("img/bg/"..option.bg..".png"))
   elseif option.bg~="aucun" then
      image.bg:blit(0, 27, Image.load("img/bg/"..option.bg..".png"), 0, 20, 480, 233)
   end
   image.bg:fontPrint(police, 13, 19, "File", couleur.texte)
   image.bg:fontPrint(police, 91, 19, "Options", couleur.texte)
   image.bg:fontPrint(police, 179, 19, "Help", couleur.texte)

   image.selec= Image.load("img/selection.png")
   image.text= Image.load("img/text.png")
   image.repertoire= Image.load("img/repertoire.png")
   image.lua= Image.load("img/lua.png")
   image.image1= Image.load("img/image.png")
   image.image2= Image.load("img/image2.png")
   image.musique= Image.load("img/musique.png")

   image.bouton= Image.load("img/luastation bouton menu.png")
   
   do
      image.fichier= Image.createEmpty(141, 20*table.getn(menu[1]))

      local transparent= image.fichier:pixel(0, 0)
      image.fichier:clear(couleur.perso)
      image.fichier:fillRect(0, 0, 4, 2, transparent)
      image.fichier:fillRect(0, 0, 2, 4, transparent)
      image.fichier:fillRect(0, 0, 3, 3, transparent)
      image.fichier:fillRect(137, 0, 4, 2, transparent)
      image.fichier:fillRect(139, 0, 2, 4, transparent)
      image.fichier:fillRect(138, 0, 3, 3, transparent)
      image.fichier:fillRect(0, 20*table.getn(menu[1])-2, 2, 2, transparent)
      image.fichier:fillRect(139, 20*table.getn(menu[1])-2, 3, 3, transparent)
      image.fichier:blit(0, 0, image.menu_h)
      for i= 1, table.getn(menu[1])-2 do
         image.fichier:blit(0, 20*i, image.menu_m)
      end
      image.fichier:blit(0, 20*table.getn(menu[1])-20, image.menu_b)
      
      image.option= Image.createEmpty(141, 20*table.getn(menu[2]))
      image.option:clear(couleur.perso)
      image.option:fillRect(0, 0, 4, 2, transparent)
      image.option:fillRect(0, 0, 2, 4, transparent)
      image.option:fillRect(0, 0, 3, 3, transparent)
      image.option:fillRect(137, 0, 4, 2, transparent)
      image.option:fillRect(139, 0, 2, 4, transparent)
      image.option:fillRect(138, 0, 3, 3, transparent)
      image.option:fillRect(0, 20*table.getn(menu[2])-2, 2, 2, transparent)
      image.option:fillRect(139, 20*table.getn(menu[2])-2, 3, 3, transparent)
      image.option:blit(0, 0, image.menu_h)
      for i= 1, table.getn(menu[2])-2 do
         image.option:blit(0, 20*i, image.menu_m)
      end
      image.option:blit(0, 20*table.getn(menu[2])-20, image.menu_b)
      
      image.aide= Image.createEmpty(141, 20*table.getn(menu[3]))
      image.aide:clear(couleur.perso)
      image.aide:fillRect(0, 0, 4, 2, transparent)
      image.aide:fillRect(0, 0, 2, 4, transparent)
      image.aide:fillRect(0, 0, 3, 3, transparent)
      image.aide:fillRect(137, 0, 4, 2, transparent)
      image.aide:fillRect(139, 0, 2, 4, transparent)
      image.aide:fillRect(138, 0, 3, 3, transparent)
      image.aide:fillRect(0, 20*table.getn(menu[3])-2, 2, 2, transparent)
      image.aide:fillRect(139, 20*table.getn(menu[3])-2, 3, 3, transparent)
      image.aide:blit(0, 0, image.menu_h)
      for i= 1, table.getn(menu[3])-2 do
         image.aide:blit(0, 20*i, image.menu_m)
      end
      image.aide:blit(0, 20*table.getn(menu[3])-20, image.menu_b)
   end
   System.currentDirectory(dire)
end

function Init()
   local a, b= type(couleur), false
   if Controls.read():r() then
      b= true
   end
   if a=="nil" or a~="table" or b then
      couleur= {
         blanc= Color.new(255,255,255),
         noir= Color.new(0,0,0),
         bleu= Color.new(0,0,255),
         gris= Color.new(128,128,128),
         vert= Color.new(0,170,0),
         mauve= Color.new(157,30,157),
         rouge= Color.new(255,0,0),
         perso= Color.new(0, 20, 46),
         texte= Color.new(0, 255, 210)
      }
   end
   a= type(option)
   if a=="nil" or a~="table" or b then
      option= {
         coloration= false,
         numero_lignes= false,
         clavier= false,
         type= 1,
         type2= 0,
         decalage= 0,
         autocomp= true,
         aide= false,
         scroll= true,
         bg= "bg2",
         hex= false,
         comm= {}
      }
   end
   a= type(cadre)
   if a=="nil" or a~="table" or b then
      cadre= {
         x= 0,
         y= 1
      }
   end
   a= type(curseur)
   if a=="nil" or a~="table" or b then
      curseur= {
         x= 0,
         y= 0
      }
   end
   a= type(statut)
   if a=="nil" or a~="table" or b then
      statut= {
         etat= "rien",
         var= 0,
         msg= System.currentDirectory().."/"..name,
         val= {0, 0, 0, 0, 0, {}, {1, 0}}
      }
   end
   a= type(aide)
   if a=="nil" or a~="table" or b then
      aide= {}
   end
   lignes= {}
   a= type(copie)
   if a=="nil" or a~="table" or b then
      copie= {}
   end
   a= type(menu)
   if a=="nil" or a~="table" or b then
      menu=
      {
         {
            "New document",
            "Open file",
            "Save as..",
            "Quit LuaStation"
         },
         {
            "Color syntax",
            "Line numbers",
            "Scroll bar",
            "Auto-complete",
            "Function help",
            "GUI color"
         },
         {
            "Help",
            "Credits",
            "Init. auto-comp.",
   --         "Init. aide"
         }
      }
   end
   return b
end



function Princip(mode)
   do
      b= Init()
      Recup_parametres()
      cadre= {
         x= 0,
         y= 1
      }
      curseur= {
         x= 0,
         y= 0
      }


      local dire= System.currentDirectory(dossier_en_cours)
      save= {}
      do
         if dossier_en_cours=="ms0:/" then
            dossier_en_cours= System.currentDirectory()
         else
            dossier_en_cours= System.currentDirectory().."/"
         end
         if mode=="hex" then
            modif= {}
            option.hex= true
            option.coloration= false
            option.numero_lignes= false
            option.autocomp= false
            option.aide= false
            f_hex= io.open(dossier_en_cours..name, "rb")
            cadre.y= 1
            Charger_bloc()
         else
            local f= io.open(name)
            for line in f:lines() do
               save[table.getn(save)+1]= line
            end
            f:close()
            option.hex= false
         end
      end
      
      if option.coloration then
         syntax= {{},{"do","if","in","or"},{"and","end","for","nil","not"},{"else","then","true"},{"break","false","local","while"},{"return"},{},{"function"}}
         Detect_com()
      end

      System.currentDirectory(dos.."Applications/lowser")
      police= Font.load("arial.ttf")
      police:setPixelSizes(0, 16)

      if option.autocomp then
         dofile("AutoCompletion.lua")
         Ajouter_fct()
      end
      if option.aide then
         dofile("aide_help.lua")   
         statut.val[7][2]= true
         statut.val[7][1]= 1
      end
      
      if image==nil or type(image)~="table" or b then
         screen:clear()
         screen:print(152, 128, "Loading...", couleur.blanc)
         screen.flip()
         image= {}
         image.curseur= Image.createEmpty(2, 10)
         image.curseur:clear(couleur.rouge)
         image.ac= Image.load("img/auto.png")
         image.help= Image.load("img/help.png")
         image.batt1= Image.load("img/batt1.png")
         image.batt2= Image.load("img/batt2.png")
         image.barre= Image.load("img/scroll_bar.png")
         image.curs_h= Image.load("img/curs_h.png")
         image.curs_m= Image.load("img/curs_m.png")
         image.curs_b= Image.load("img/curs_b.png")
         image.menu_h= Image.load("img/menu_h.png")
         image.menu_m= Image.load("img/menu_m.png")
         image.menu_b= Image.load("img/menu_b.png")
   
         Creer_img()
         Creer_curseur()
      end
      System.currentDirectory(dire)
   end
   
   Process()
   option.compteur= 0

   while true do
      pad= Controls.read()
      option.compteur= option.compteur+1
      if oldpad~=pad or pad:l() or pad:r() then
         option.compteur= 0
      end
      if option.numero_lignes then
         option.decalage= math.floor(math.log10(table.getn(save)))+1
      elseif option.scroll then
         option.decalage= 1
      else
         option.decalage= 0
      end
      Assigner_texte()
      Afficher()
      if option.hex then
         if Evenement_() then
            break
         end
      else
         if Evenement() then
            break
         end
      end
      screen.waitVblankStart()
      screen.flip()
      oldpad= pad
   end
end
